/*
TASK:F
LANG:C++
*/

#include <stdio.h>
#include <vector>
#include <math.h>
#include <queue>
#include <algorithm>

using namespace std;

#define IN "f.in"
#define OUT "f.out"
#define MAXN 1024
#define MAXM 4096
#define FIX 10000
#define INF 1e15
#define X first
#define Y second


#define int long long

inline int min (int a,int b) {if (a < b) return a;else return b;}
inline int max (int a,int b) {if (a > b) return a;else return b;}

typedef struct edge {
	int a,b,l,id;
	edge() {a = b = l = id = 0;}
	edge(int aa,int bb,int ll,int iid) {a = aa;b = bb;l = ll;id = iid;}
} newedge;

int N,M;
edge e[MAXM];
vector<edge> ar[MAXN];
pair<int,int> m[MAXN][MAXN];
int r[MAXN][MAXN];


int can (int v) {
	return 0;
}


typedef struct node {
	int v,d;
	node () {v = d = 0;}
	node (int nn,int dd) {v = nn;d = dd;}
	bool operator <(const node & h) const {
		if (d > h.d) return true;
		else return false;
	}
} newnode;

priority_queue <node> q;

int d[MAXN];
int dijikstra (int v) {
	q.push(node(v,0));

	for (unsigned i=1; i<=N; i++) d[i] = (int)INF;

	d[v] = 0;
	while (!q.empty()) {
		node p = q.top(); q.pop();
		if (d[p.v] != p.d) continue;
		
		v = p.v;
		for (int i=0; i<ar[v].size(); i++) {
			int nd = p.d + ar[v][i].l;
			int nv = ar[v][i].b;
			if (d[nv] > nd) {
				d[nv] = nd;
				q.push(node(nv,nd));
			}
		}
	}
	return 0;
}
int init () {
	for (int i=1; i<=N; i++) {
		dijikstra(i);
		for (int j=1; j<=N; j++) {
			m[i][j].Y = j;
			m[i][j].X = d[j];
			r[i][j] = d[j];
		}
		sort(m[i]+1,m[i]+1+N);
		reverse(m[i]+1,m[i]+1+N);
	}
	return 0;
}

int read();
int init();

int solve () {
	int ret = (int)INF;
	for (int i=1; i<=M; i++) {
		int a = e[i].a;
		int b = e[i].b;
		int l = e[i].l;

		
		int d1 = m[a][1].X;
		int v1 = m[a][1].Y;
		int d2 = m[b][1].X;
		int v2 = m[b][1].Y;

		ret = min(ret,max(d1,d2));
		
		if (d1 == l + r[b][v1]) {
			if (d2 == l + r[a][v2]) {
				ret = min(ret,( m[a][1].X + m[b][1].X - l ) / 2);	
			} else {
				ret = min(ret,( m[a][1].X + m[b][1].X ) / 2);	
			}
		} else {
			if (d2 == l + r[a][v2]) {
				ret = min(ret,( m[a][1].X + m[b][1].X ) / 2);	
			} else {
				ret = min(ret,( m[a][1].X + m[b][1].X + l) / 2);	
			}
		}
		
	}
	return ret;
}
#undef int
int main () {
#define int long long
	//freopen(IN,"r",stdin);
	//freopen(OUT,"w",stdout);

	read();
	init();

	int ans = solve();printf("%.4lf\n",(double)ans/FIX);
	return 0;
}


int read() {
	scanf("%lld%lld",&N,&M);
	for (int i=1; i<=M; i++) {
		double c;
		int a,b,l;
		scanf("%lld%lld%lf",&a,&b,&c);
		l = (long long)floor(c*FIX + 0.5);
		e[i].a = a;		e[i].b = b;		e[i].l = l;		e[i].id = i;
		ar[a].push_back(edge(a,b,l,i));
		ar[b].push_back(edge(b,a,l,i));	
	}
	return 0;
}

