{
TASK: f
LANG: PASCAL
}
program f;

const
	MAXN					= 1001;
	MAXM					= 2900;
	e					= 0.00000001;
	INF					= maxlongint div 3;

type
	Integer					= LongInt;
	TEdge					= record
		t, n				: Integer;
		d				: Real;
	end;
	TArray					= Array [1 .. MAXN] of Real;

var
	g					: Array [1 .. MAXM * 2] of TEdge;
	head					: Array [1 .. MAXN] of Integer;
	used					: Array [1 .. MAXN] of Boolean;
	heap 					: Array [1 .. MAXN] of Real;
	hin, inh				: Array [1 .. MAXN] of Integer;
	gn, n, m, i, x, y, hn			: Integer;
	d, answ					: Real;

procedure readInput;
begin
	readln(n, m);
	gn := 0;
	for i := 1 to n do head[i] := 0;
	for i := 1 to m do begin
		readln(x, y, d);
		gn := gn + 1; g[gn].t := y; g[gn].d := d; g[gn].n := head[x]; head[x] := gn;
		gn := gn + 1; g[gn].t := x; g[gn].d := d; g[gn].n := head[y]; head[y] := gn;
	end;
end;

procedure swap(var a, b: Integer);
var
	t					: Integer;
begin
	t := a; a := b; b := t;
end;

procedure swaph(var a, b: Real);
var
	t					: Real;
begin
	t := a; a := b; b := t;
end;

procedure delheap;
var
	i, imin					: Integer;
begin
	swaph(heap[1], heap[hn]);
	inh[hin[hn]] := 1;
	hin[1] := hin[hn];
	hn := hn - 1;
	i := 1;
	while (i * 2 <= hn) do begin
		if (i * 2 = hn) then imin := i * 2
		else if (heap[i * 2] < heap[i * 2 + 1]) then imin := i * 2
		else imin := i * 2 + 1;
		if (heap[i] < heap[imin]) then break;
		swap(inh[hin[i]], inh[hin[imin]]);
		swap(hin[i], hin[imin]);
		swaph(heap[i], heap[imin]);
		i := imin;
	end;
end;

procedure update(i: Integer);
begin
	while (i div 2 > 0) and (heap[i] < heap[i div 2]) do begin
		swap(inh[hin[i]], inh[hin[i div 2]]);
		swap(hin[i], hin[i div 2]);
		swaph(heap[i], heap[i div 2]);
		i := i div 2;
	end;
end;

function op(i: Integer): Integer;
begin
	if (i mod 2 = 1) then op := i+1 else op := i-1;
end;

procedure Solve;
var
	i, j, x, c, k, l			: Integer;
	max, d, a, b, z2			: Real;
	aarr, barr				: TArray;

procedure dij(v: Integer; var a: TArray);
var
	j, x, c					: Integer;
	d					: Real;
begin
	hn := 1;
	heap[1] := 0.00000000;
	hin[1] := v; inh[v] := 1;
	for j := 1 to n do begin
		used[j] := False;
		if (v <> j) then begin
			hn := hn + 1;
			heap[hn] := inf;
			hin[hn] := j;
			inh[j] := hn;
		end;
	end;
	for j := 1 to n do begin
		c := hin[1];
		d := heap[1];
		delheap;
                a[c] := d;
		if (abs(d-inf) <= e) then continue;
		x := head[c];
		used[c] := True;
		while (x > 0) do begin
			if (x <> l) and (x <> op(l)) and (not used[g[x].t]) and
			(heap[inh[g[x].t]] > d + g[x].d) then begin
				heap[inh[g[x].t]] := d + g[x].d;
				update(inh[g[x].t]);
			end;
			x := g[x].n;
		end;
	end;
end;

begin
	answ := maxlongint;
	for i := 1 to n do begin
		hn := 1;
		heap[1] := 0.00000000; hin[1] := i; inh[i] := 1;
		for j := 1 to n do begin
			used[j] := False;
			if (i <> j) then begin
				hn := hn + 1;
				heap[hn] := inf;
				hin[hn] := j;
				inh[j] := hn;
			end;
		end;
		max := 0.00000000;
		for j := 1 to n do begin
			c := hin[1];
			d := heap[1];
			delheap;
			if (max < d) then max := d; { max < d -- always true }
			x := head[c];
			used[c] := True;
			while (x > 0) do begin
				if (not used[g[x].t]) and (heap[inh[g[x].t]] > d + g[x].d) then begin
					heap[inh[g[x].t]] := d + g[x].d;
					update(inh[g[x].t]);
				end;
				x := g[x].n;
			end;
		end;
		if (answ > max) then answ := max;
	end;

	for k := 1 to n do begin
		l := head[k];
		while (l > 0) do begin
			dij(k, aarr);
			dij(g[l].t, barr);
			for i := 1 to n do
				if (aarr[i] < barr[i]) then barr[i] := 0.00000000
				else aarr[i] := 0.00000000;
			for i := 1 to n do begin
				if (abs(aarr[i]-inf) <= e) then aarr[i] := 0.00000000;
				if (abs(barr[i]-inf) <= e) then barr[i] := 0.00000000;
			end;
			a := 0.00000000;
			b := 0.00000000;
			for i := 1 to n do begin
				if (aarr[i] > a) then a := aarr[i];
				if (barr[i] > b) then b := barr[i];
			end; 
			if (a+g[l].d <= b) or (b+g[l].d <= a) then begin 
				l := g[l].n;
				continue;
			end;
			z2 := (a+g[l].d-b)/2;
			if (answ > b+z2) then answ := b+z2;
			l := g[l].n;
		end;
	end;
	
	writeln(answ:1:4);
end;

begin
	readInput;
	Solve;
end.