#include <stdlib.h>
#include <stdio.h>

/*
 * Finds the smallest number of the type
 * 1.....1 in base p, so that
 * 1.....1 % a = 0
 * n - a's numbers in base p
 */
int findmin( int a, int p );

int main() {
	int a, p;
	int minn, mint;
	scanf( "%d %d", &a, &p );
	if ( p == 1 ) {
		printf( "0\n" );
		return 0;
	}
	int k;
	minn = 0;
	int tmpn;
	mint = 0;
	for ( k = 1; k < p; ++k ) {
		if ( (a/k)*k != a ) continue;
		tmpn = findmin( a/k, p );
		if ( tmpn != 0 && (tmpn < minn || minn == 0) ) {
			minn = tmpn;
			mint = k;
		}
	}
	if ( minn == 0 ) {
		printf( "0\n" );
	}
	else {
		printf( "%d %d\n", minn, mint );
	}
	return 0;
}

int findmin( int a, int p ) {
	if ( a == 0 )
		return 0;
	if ( a == 1 )
		return 1;
	/*
	 * When true, a=...0 in base p
	 */
	if ( (a/p)*p == 0 )
		return 0;
		
	int d;
	char *got = (char*)malloc( a*sizeof(char) );
	int i;
	int k = p%a;
	for ( i = 0; i < a; ++i )
		got[i] = 0;
	
	/* 1/x = 0 + rem(1) */
	d = (k+1)%a;
	got[1] = 1;
	i = 2;
	while ( got[d] == 0 && d != 0 ) {
		got[d] = 1;
		++i;
		d = (d*k + 1)%a;
	}
	free( got );
	if ( d == 0 )
		return i;
	return 0;
}


