#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <string.h>

const int MAX_DENOM = 1000000;

class Solution {
		int digit;
		int count;
	public:
		Solution(int digit,int count) {
			this->digit = digit;
			this->count = count;
		}
		int get_digit() {
			return digit;
		}
		int get_count() {
			return count;
		}
};

int denom;
int radix;
bool seen_rem[MAX_DENOM];

void load()
{
	fscanf(stdin,"%d%d",&denom,&radix);		
}

// returns ( base^0 + base^1 + ... + base^(count-1) ) % mod
int geom_series_rem(int base, int count, int mod)
{
	int result = 0;
	int base_exped = 1;
		
	for (int i=0;i<count;i++) {
		result = ( result + base_exped ) % mod;
		base_exped = ( base_exped * base) % mod;
	}
	
	return result % mod;
}

Solution solve()
{
	int nom_length;
	int digit;
		
	for (nom_length=1;true;nom_length++) {
		int rem = geom_series_rem(radix,nom_length,denom);
		if (seen_rem[rem])
			return Solution(0,0);
		else
			seen_rem[rem] = true;
		
		for (digit=1;digit<radix;digit++) {			
			if ( ( digit*rem ) % denom == 0 ) 						 
				return Solution(digit,nom_length);
		}		
	}	
}

void save(Solution sol)
{
	if (sol.get_count() > 0)
		printf("%d %d\n",sol.get_count(),sol.get_digit());
	else
		printf("0\n");
}

int main()
{
	memset(seen_rem,0,sizeof(seen_rem));
	load();
	save(solve());
	
	return 0;	
}
