#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <string.h>

struct Query {
	int vertex1;
	int vertex2;
};

//const bool DEBUG_MODE = true;
const bool DEBUG_MODE = false;

const int MAX_VERTEX_COUNT = 100005;
const int MAX_QUERY_COUNT = 101;

int parent[MAX_VERTEX_COUNT];
Query query[MAX_QUERY_COUNT];
int vertex_count;
int query_count;
bool is_on_root_path[MAX_VERTEX_COUNT];

void load()
{
	FILE *fin;
	
	if (DEBUG_MODE)
		fin = fopen("/home/olymp/tests/meet.in2","r");
	else
		fin = stdin;
	
	fscanf(fin,"%d%d",&vertex_count,&query_count);
	parent[0] = -1;
	
	int i;
	for (i=0;i<vertex_count;i++)
		fscanf(fin,"%d",&parent[i+1]);
	vertex_count++;
	for (i=0;i<query_count;i++)		
		fscanf(fin,"%d%d",&(query[i].vertex1),&(query[i].vertex2));
			
	fclose(fin);
}

int do_solve(int vertex1,int vertex2) 
{
	memset(is_on_root_path,0,sizeof(is_on_root_path));
	
	int cur_vertex = vertex1;
	while (cur_vertex != -1) {
		is_on_root_path[cur_vertex] = true;
		cur_vertex = parent[cur_vertex];	
	}
	
	cur_vertex = vertex2;
	while (is_on_root_path[cur_vertex] == false) {		
		cur_vertex = parent[cur_vertex];	
	}
	
	return cur_vertex;
}

void solve() 
{
	for (int i=0;i<query_count;i++) {
		printf("%d\n",do_solve(query[i].vertex1,query[i].vertex2));
	}
}

int main()
{	
	load();
	solve();
	
	return 0;
}
