program SEGMENT;

type
   TTriangle = record
      x1, y1: longint;
      x2, y2: longint;
      x3, y3: longint;
   end;

type
   TPoint = record
      x: longint;
      y: longint;
   end;

var triang     : TTriangle;
var a1, b1     : longint;
var a2, b2     : longint;
var crosspoint1: TPoint;
var crosspoint2: TPoint;
var dist       : single;

var m_c  : double;
var m_kx : double;
var m_ky : double;

procedure fill_params();
begin
   read(triang.x1);
   read(triang.y1);
   read(triang.x2);
   read(triang.y2);
   read(triang.x3);
   read(triang.y3);
   read(a1);
   read(b1);
   read(a2);
   read(b2);
end;

procedure prava_get_k(x1, y1, x2, y2: longword; c: double;
                        var kx, ky: double);
begin
   if (x1-c=0) and (x2-c=0) then begin
      kx := 1;
      exit;
   end else begin
      if (x1-c) <> 0 then begin
         kx := abs((y1-c)/(x1-c))
      end else begin
         if (x2-c) <> 0 then
            kx := abs((y2-c)/(x2-c));
      end;
   end;
   if (y1-c=0) and (y2-c=0) then begin
      ky := 1;
      exit;
   end else begin
      if (y1-c) <> 0 then begin
         ky := abs((x1-c)/(y1-c));
      end else begin
         if (y2-c) <> 0 then
            ky := abs((x2-c)/(y2-c));
      end;
   end;
end;

function prava_get_c(x1, y1, x2, y2: longword): double;
var c: double;
var a1, b1, a2, b2: double;
begin
   a1 := x1;
   b1 := y1;
   a2 := x2;
   b2 := y2;
   if (b1 = 0) or (b2 = 0) then begin
      prava_get_c := 0;
      exit;
   end;
   while abs((a1/b1) - (a2/b2)) >= 0.0001 do begin
      c  := c + ((a1/b1) - (a2/b2));
      a2 := x2-c;
      a1 := x1-c;
   end;
   prava_get_c := c;
end;

function prava_get_x(ky, c, y: double): double;
begin
   prava_get_x := y*ky + c;
end;

function prava_get_y(kx, c, x: double): double;
begin
   prava_get_y := x*kx + c;
end;

function is_crossed(p_kx, p_ky, p_c, o_kx, o_ky, o_c, o_x1, o_y1, o_x2, o_y2: double): boolean;
var x_razl, y_razl: double;
var x, y: longword;
begin
   is_crossed := false;
   if o_x1 > o_x2 then x_razl := o_x1 - o_x2 else x_razl := o_x2 - o_x1;
   if o_y1 > o_y2 then y_razl := o_y1 - o_y2 else y_razl := o_y2 - o_y1;
   if x_razl > y_razl then begin
      for x := round(o_x1)*1000 to round(o_x2)*1000 do begin
         if abs(prava_get_y(o_kx, o_c, x/1000) - prava_get_y(m_kx, m_c, x/1000)) <= 0.0001 then begin
            is_crossed := true;
            exit;
         end;
      end;
      for x := round(o_x2)*1000 to round(o_x1)*1000 do begin
         if abs(prava_get_y(o_kx, o_c, x/1000) - prava_get_y(m_kx, m_c, x/1000)) <= 0.0001 then begin
            is_crossed := true;
            exit;
         end;
      end;
   end else begin
      for y := round(o_y1)*1000 to round(o_y2)*1000 do begin
         if round(prava_get_x(o_ky, o_c, y)) = round(prava_get_x(m_ky, m_c, y)) then begin
            is_crossed := true;
            exit;
         end;
      end;
      for y := round(o_y2)*1000 to round(o_y1)*1000 do begin
         if abs(prava_get_y(o_ky, o_c, y/1000) - prava_get_x(m_ky, m_c, y/1000)) <= 0.0001 then begin
            is_crossed := true;
            exit;
         end;
      end;
   end;
end;

function find_crosspoints(): boolean;
var t12_kx, t12_ky, t12_c: double;
var t13_kx, t13_ky, t13_c: double;
var t23_kx, t23_ky, t23_c: double;
var y, x: longword;
var cross_on_12: boolean;
var cross_on_13: boolean;
var cross_on_23: boolean;
begin
   find_crosspoints := true;
   m_c := prava_get_c(a1, b1, a2, b2);

   prava_get_k(a1, b1, a2, b2, m_c, m_kx, m_ky);

   t12_c := prava_get_c(triang.x1, triang.y1, triang.x2, triang.y2);

   prava_get_k(triang.x1, triang.y1, triang.x2, triang.y2, t12_c, t12_kx, t12_ky);

   t13_c := prava_get_c(triang.x1, triang.y1, triang.x3, triang.y3);

   prava_get_k(triang.x1, triang.y1, triang.x3, triang.y3, t13_c, t13_kx, t13_ky);

   t23_c := prava_get_c(triang.x2, triang.y2, triang.x3, triang.y3);

   prava_get_k(triang.x2, triang.x2, triang.x3, triang.y3, t23_c, t23_kx, t23_ky);

   cross_on_12 := is_crossed(m_kx, m_ky, m_c, t12_kx, t12_ky, t12_c, triang.x1, triang.y1, triang.x2, triang.y2);
   cross_on_13 := is_crossed(m_kx, m_ky, m_c, t13_kx, t13_ky, t13_c, triang.x1, triang.y1, triang.x3, triang.y3);;
   cross_on_23 := is_crossed(m_kx, m_ky, m_c, t23_kx, t23_ky, t23_c, triang.x2, triang.y2, triang.x3, triang.y3);;
   if cross_on_12 then writeln('1-2');
   if cross_on_13 then writeln('1-3');
   if cross_on_23 then writeln('2-3');
end;

procedure calc_dist();
begin
   dist :=
      sqrt(
         (crosspoint2.x-crosspoint1.x)
        *(crosspoint2.x-crosspoint1.x)
        +
         (crosspoint2.y-crosspoint1.y)
        *(crosspoint2.y-crosspoint1.y)
          );
end;

begin
   fill_params();
   if not find_crosspoints() then begin
      writeln('Nevalidni vhodni danni!');
      exit;
   end;
   calc_dist();
   writeln(dist);
end.
