/*
FROM: NOI2 2006 A
PROB: meet
KEYW: dfs with stack (iterative)
*/

#include <cstdio>
#include <algorithm>
#include <stack>

using std::min;

const int MAXN = 1 << 17;

int N, M;
int prev[MAXN];
int lvl[MAXN];

void dfs (int a) {
	std::stack <int> st;

	st.push (a);

	int crnt;
	while (!st.empty ()) {
		crnt = st.top ();
		if (lvl[prev[crnt]] != -1) {lvl[crnt] = lvl[prev[crnt]] + 1; st.pop ();}
		else st.push (prev[crnt]);
	}
}

int main () {
	scanf ("%d %d", &N, &M);

	int i;
	for (i = 1; i <= N; ++i)
		scanf ("%d", prev + i);
    prev[0] = -1;//just in case

	for (i = 1; i <= N; ++i)
		lvl[i] = -1;
    lvl[0] = 0;//the city

	for (i = 1; i <= N; ++i)
		if (lvl[i] == -1)
			dfs (i);
/*
    for (i = 0; i <= N; ++i)
		printf ("%d -> %d\n", i, lvl[i]);
*/
	int a, b;
	int minlvl;
	for (i = 0; i < M; ++i) {
		scanf ("%d %d", &a, &b);

		minlvl = min (lvl[a], lvl[b]);
		while (lvl[a] > minlvl) a = prev[a];
		while (lvl[b] > minlvl) b = prev[b];
		while (a != b) {
			a = prev[a];
			b = prev[b];
		}
		printf ("%d\n", a);
	}

	return 0;
}

