#include <map>
#include <cstdio>
#include <vector>

typedef signed int ind;

const char *read_ind = "%d";
const char *write_ind = "%d";

const ind none = -1;

class chain
{
public:
	chain() {}
	chain(const ind& n, const ind& e) : prev(n), lowest(e) {level[e] = 0;}

	ind prev;
	ind lowest;
	std::map<ind, ind> level;	/* NB: Low level actually means high village. */
};

int main()
{
	ind n, m;
	std::scanf(read_ind, &n);
	std::scanf(read_ind, &m);
	std::vector<chain> tree(n+1);
	tree[0].prev = none;
	tree[0].lowest = 0;
	std::vector<ind> ref(n+1, 0);
	ind x;
	std::map<ind, ind> find_chain;
	for (ind i = 1; i <= n; i++)
	{
		std::scanf(read_ind, &x);
		ref[x]++;
		tree[i].prev = x;
		tree[i].lowest = i;
		tree[i].level[i] = 0;
		find_chain[i] = i;
	}
	tree[0].level[0] = 0;
	find_chain[0] = 0;

	{
		std::vector<bool> visited(n+1, false);
		for (ind i = 1; i <= n; i++)
		{/* Can start from 1 because root is surely not a leaf. */
			if (ref[i]) continue;

			ind curr_chain = i;
			ind curr_element = i;
			visited[curr_element] = true;
			while (tree[curr_element].prev != none)
			{
				curr_element = tree[curr_element].prev;
				if (visited[curr_element]) break;
				visited[curr_element] = true;
				if (ref[curr_element] == 1)
				{
					tree[curr_chain].level[curr_element] = tree[curr_chain].level.size()-1;
					tree[curr_chain].prev = tree[curr_element].prev;
					find_chain[curr_element] = find_chain[curr_chain];
				} else curr_chain = curr_element;
			}
		}
	}

	/*for (ind i = 0; i <= n; i++)
	{
		std::printf(write_ind, i);
		std::printf(" ");
		std::printf(write_ind, find_chain[i]);
		std::printf(" ");
		for (std::map<ind, ind>::iterator it = tree[find_chain[i]].level.begin(); it != tree[find_chain[i]].level.end(); it++)
		{
			std::printf("(");
			std::printf(write_ind, it->first);
			std::printf(", ");
			std::printf(write_ind, it->second);
			std::printf(") ");
		}
		std::printf("\n");
	}*/

	for (ind i = 0; i < m; i++)
	{
		ind from, to;
		std::vector<bool> visited(n+1, false);
		std::scanf(read_ind, &from);
		std::scanf(read_ind, &to);

		ind c = find_chain[from];
		visited[c] = true;
		while (tree[c].prev != none)
		{
			c = tree[c].prev;
			visited[c] = true;
		}

		c = find_chain[to];
		while (!visited[c]) c = tree[c].prev;

		/* Now tree[c] is the nearest common predecessor in the chain-tree. */
		std::map<ind, ind>::iterator itf, itt;
		if ((itf = tree[c].level.find(from)) != tree[c].level.end())
			if ((itt = tree[c].level.find(to)) != tree[c].level.end())
				std::printf(write_ind, (itf->second > itt->second ? from : to));
			else std::printf(write_ind, from);
		else if ((itt = tree[c].level.find(to)) != tree[c].level.end())
				std::printf(write_ind, to);
			else std::printf(write_ind, tree[c].lowest);
		
		std::printf("\n");
	}

	return 0;
}
