// Stoyan Kapralov

#include <iostream>
#include <vector>
#include <stack>
using namespace std;

const int NMAX = 10000+10;

struct edge
{  int u,v;
   edge(int u1=0, int v1=0) 
   { u = u1; v = v1; }
   bool operator==(const edge & e)
   { return (u==e.u && v==e.v) || 
            (u==e.v && v==e.u);
   }
};
    
stack<edge> s;    
    
vector<int> a[NMAX];
int pr[NMAX], num[NMAX], low[NMAX];

int n,m;

int dfsnum, maxcnt;

void dfs(int u)
{  dfsnum++;
   low[u] = num[u] = dfsnum;
   for(int i=0; i<a[u].size(); i++)
   { int v = a[u][i];
     if(num[v] == 0)
     { s.push(edge(u,v));
       pr[v] = u;
       dfs(v);
       if(low[u]>low[v]) low[u]=low[v];
       if(low[v]>=num[u])
       { int cnt = 0;
         edge e;
         do
         { e = s.top();  s.pop();
           cnt++;
         } while(! (e == edge(u,v)));
         if(maxcnt < cnt) maxcnt = cnt; 
       }                  
     }
     else
       if(v!=pr[u] && num[u]>num[v]) 
       { s.push(edge(u,v));
         if(low[u]>num[v]) low[u]=num[v];
       }  
   }
}


int main()
{  cin >> n >> m;
   
   for(int i=0; i<m; i++)
   { int u,v;
     cin >> u >> v;
     a[u].push_back(v);
     a[v].push_back(u);
   }
   
   dfsnum = 0;
   for(int u=1; u<=n; u++)
     num[u]=0;
     
   maxcnt = 0;
   for(int u=1; u<n; u++)
     if(num[u]==0)
     { pr[u]=0; dfs(u); }
      
   cout << maxcnt << endl;
   return 0;  
}   

