/*
NAME: Petar Ivanov
*/

#include <cstdio>
#include <vector>
#include <ctime>
#include <algorithm>
using namespace std;

const int MAX_N = 1024;

time_t start = clock();

int n, m;
int M[MAX_N][MAX_N];
vector<int> A[MAX_N];
int C[MAX_N], br[MAX_N];
bool V[MAX_N];
int res;
int critic[MAX_N];
int edges, ans=0;

int Q[MAX_N], qu;

void input ()
{
	int i, a, b;
	
	scanf ("%d%d", &n, &m);
	
	while (n>=MAX_N); 
	
	for (i=0; i<m; i++) {
		scanf ("%d%d", &a, &b);
		M[a][b] = M[b][a] = 1;
		A[a].push_back (b);
		A[b].push_back (a);
	}
}

void colour_dfs (int p, int col)
{
	int i;
	C[p] = col;
	br[col]++;
	
	for (i=0; i<A[p].size(); i++)
		if (!C[ A[p][i] ])
			colour_dfs (A[p][i], col);
}

void vertex_cnt_dfs (int p)
{
	int i;
	res++;
	V[p] = 1;
	
	for (i=0; i<A[p].size(); i++)
		if (!V[ A[p][i] ])
			vertex_cnt_dfs (A[p][i]);
}

void edge_cnt_dfs (int p)
{	
	int i;
	
	V[p] = 1;
	
	if (critic[p]) {
		for (i=0; i<qu; i++)
			if (M[p][ Q[i] ])
				edges++;

		Q[qu++] = p;
		return;
	}
	
	for (i=0; i<A[p].size(); i++) {
		if (p < A[p][i] || critic[ A[p][i] ]) edges++;
		if (!V[ A[p][i] ]) edge_cnt_dfs (A[p][i]);
	}
}

void solve ()
{
	int i;
	
	for (i=1; i<=n; i++)
		if (!C[i])
			colour_dfs (i,i);
	
	for (i=1; i<=n; i++) {
		res=1;
		memset (V, 0, sizeof(V));
		V[i] = 1;
		
		if (br[ C[i] ]>1 && (vertex_cnt_dfs(A[i][0]), res!=br[ C[i] ]))
			critic[i]=1;
	}
	
	for (i=1; i<=n && clock()-start < 0.95*CLOCKS_PER_SEC; i++)
		if (!critic[i]) {
			memset (V, 0, sizeof(V));
			edges=qu=0;
			edge_cnt_dfs (i);
			if (edges>ans) ans=edges;
		}
}

int main ()
{
	//freopen ("bicon.in", "r", stdin);
	
	input ();
	solve ();
	
	printf ("%d\n", ans);
	
	return 0;
}
