#include <iostream>
#include <math.h>
#include <algorithm>
#include <iomanip>
#define eps 1e-9
#define step 0.001
using namespace std;

struct point 
{
       double x, y;
       point(){}
       point(double _x, double _y):x(_x), y(_y){}
       point operator-(point p)
       {
             return point(x-p.x, y-p.y);
       }
} P[200];
int N1, N2, N;
point V[10000];
int cnt;
double cross(point p1, point p2)
{
       return p1.x*p2.y - p1.y*p2.x;
}

bool color(int i)
{
     return i < N1;
}

bool eq(double a, double b)
{
     return fabs(a-b)<eps;
}

bool check(point p, point v)
{    
     int c[2] = {0, 0};
     for (int i = 0; i < N; i++)
     {
         double C = cross(v, P[i] - p);
         if (eq(C, 0)) return 0;
         
         if (C > 0)c[color(i)]++;
         else c[color(i)]--;
     }
//if (eq(p.x, 0.999) && eq(p.y, 2.) && eq(v.x, 0.) && eq(v.y, -0.5))
//cout << c[0] << " " << c[1] << endl;


     return (c[0] == 0 && c[1] == 0);
}
int main()
{
    cin >> N1;
    for (int i = 0; i < N1; i++)
     cin >> P[i].x >> P[i].y;
    cin >> N2;
    N = N1 + N2;
    for (int i = N1; i < N; i++)
     cin >> P[i].x >> P[i].y;
    
    for (int i = 0; i < N; i++)
     for (int j = i+1; j < N; j++)
      V[cnt++] = P[i] - P[j];
    
    //cout << N << " " << N1*N2 << endl;
    for (int i = 0; i < N; i++)
     for (int j = 0; j < cnt; j++)
      if (check(point(P[i].x-step, P[i].y), V[j]))
      {
         while (fabs(V[j].x) > 1. - eps || fabs(V[j].y) > 1. - eps)
          V[j].x /= 2., V[j].y /= 2.;   
         cout << setiosflags(ios::fixed) << setprecision(8) <<
                 P[i].x - step << " " << P[i].y << " " << V[j].x << " "<< V[j].y << endl; 
         return 0;
      }
      else if (check(point(P[i].x, P[i].y + step), V[j]))
      {
         while (fabs(V[j].x) > 1. - eps || fabs(V[j].y) > 1. - eps)
          V[j].x /= 2., V[j].y /= 2.;   
         cout << setiosflags(ios::fixed) << setprecision(8) <<
                 P[i].x << " " << P[i].y + step << " " << V[j].x << " "<< V[j].y << endl; 
         return 0;
      }
      
    cout << "0 0 0 0" << endl;
    return 0;
}
