#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <math.h>
#include <cstdlib>
using namespace std;

const int MAXN = 1 << 8;

struct P {
    double x, y;
    P () {}
    P (double _x, double _y): x (_x), y (_y) {}
} a[MAXN], b[2*MAXN];

int i, j, n1, n2, br;
double r1, r2, med;

double eps = 0.00000001;
bool eq (double d1, double d2) {
    if (fabs (d1 - d2) < eps) return 1;
    return 0;
}

double eps2 = 0.00000000001;
bool eq2 (double d1, double d2) {
    if (fabs (d1 - d2) < eps2) return 1;
    return 0;
}

double cross (P p1, P p2, P p3) {
    return p1.x*(p2.y-p3.y)+p2.x*(p3.y-p1.y)+p3.x*(p1.y-p2.y);
}

void found_sol () {
    //cout << b[i].x << " " << b[i].y << " ";
    printf ("%.8lf %.8lf ", b[i].x, b[i].y);
    double d1 = b[i].x - b[j].x;
    double d2 = b[i].y - b[j].y;
    if (fabs(d1) > 1.0 || fabs(d2) > 1.0) {
        double del = sqrt (d1*d1 + d2*d2);
        //if (del == 0.0); // ?
        d1 /= del;
        d2 /= del;
    }
    //cout << b[i].x << " " << b[i].y << endl;
    printf ("%.8lf %.8lf\n", d1, d2);
}

int k, c1, c2;
double cr;
void go () {
    //printf ("%d %d %f %f %f %f:\n", i, j, b[i].x, b[i].y, b[j].x, b[j].y);
    c1 = 0; c2 = 0;
    for (k = 1; k <= n1; k++) {
        cr = cross (b[i], b[j], a[k]);
        if (eq2 (cr, 0.0)) return; // <--
        if (cr < 0.0) c1++;
        else c2++;
    }
    //printf (" %d %d\n", c1, c2);
    if (c1 != c2) return;
    
    c1 = 0; c2 = 0;
    for (k = n1 + 1; k <= n1 + n2; k++) {
        cr = cross (b[i], b[j], a[k]);
        if (eq2 (cr, 0.0)) return; // <--
        if (cr < 0.0) c1++;
        else c2++;
    }
    //printf (" %d %d\n", c1, c2);
    if (c1 == c2) {
        //printf ("FOUND\n");
        found_sol ();
        exit (0);
    }
}

void solve () {
    // r
    double x, y;
    for (i = 1; i <= n1 + n2; i++) {
        x = a[i].x;
        y = a[i].y - 0.00001;
        b[++br] = P (x, y);
        y = a[i].y + 0.00001;
        b[++br] = P (x, y);
    }
    // --
    //printf ("STEP 1 FINISHED\n");
    int dudu;
    for (i = 1; i < br; i++) {
        dudu = i % 2;
        for (j = i + 1 + dudu; j <= br; j++) {
            //if (i % 2 + j % 2 == 1) {
                go ();
            //}
        }
    }
    printf ("0 0 0 0\n");
} 

int main () {
    //freopen ("a2.inp", "rt", stdin);
    //freopen ("a2.out", "wt", stdout);
    //scanf ("%d", &n1);
    cin >> n1;
    for (i = 1; i <= n1; i++) cin >> a[i].x >> a[i].y;
    //scanf ("%d", &n2);
    cin >> n2;
    for (i = 1; i <= n2; i++) cin >> a[n1+i].x >> a[n1+i].y;
    solve ();
    return 0;
}
