#include <cstdio>
#include <iostream>
#include <bitset>
#include <set>
using namespace std;

#define f(i, n)								for(int i = 0; i < n; i ++)
#define MAX_N								(1000)
#define MAX_O								(100)
#define Get_Time(start)						(double(clock() - start) / double(CLOCKS_PER_SEC))

typedef struct cmp
{

bool operator() (const bitset<MAX_N> &a, const bitset<MAX_N> &b) const
{
	f(i, MAX_N) if(a[i] != b[i]) return a[i] < b[i];
	
	return false;
}

};

clock_t start = clock();

int N, M;
int a[MAX_N][MAX_O];
int size[MAX_N];
int path[MAX_N];
int path_size;
int index;
bool used[MAX_N];
bitset<MAX_N> c[MAX_N];
set< bitset<MAX_N>, cmp> u;
int ans;

void Read()
{
register int x, y;
	
	scanf("%d %d", &N, &M);
	
	f(i, M)
	{
		scanf("%d %d", &x, &y);
		
		x --;
		y --;
		
		a[x][size[x] ++] = y;
		a[y][size[y] ++] = x;
	}
}

void DFS(int node)
{
	path[path_size ++] = node;
	used[node] = true;
	
	if(0.7 < Get_Time(start)) return;
	
	f(i, size[node])
	{
		int next = a[node][i];
		
		if(!used[next])
		{
			DFS(next);
		}
		else
		{
			if(path[path_size - 2] != next)
			{
				for(index = path_size - 2; path[index] != next; index --);
				
				for(int j = index; j < path_size; j ++)
				{
					for(int k = index; k < path_size; k ++)
					{
						c[path[j]][path[k]] = true;
					}
				}
			}
		}
	}
	
	path_size --;
	used[node] = false;
}

inline bool is_ok(const bitset<MAX_N> &b)
{
	f(i, N) if(b[i] && ((c[i] & b) != b)) return false;
	
	return true;
}

inline void check_ans(const bitset<MAX_N> &b)
{
register int edges = 0;
	
	f(i, N) if(b[i]) f(j, size[i]) if(b[a[i][j]]) edges ++;
	
	edges /= 2;
	
	if(ans < edges) ans = edges;
}

void rec(bitset<MAX_N> b)
{
	if(0.9 < Get_Time(start))
	{
		printf("%d\n", ans);
		
		exit(0);
	}
	
	if(u.count(b)) return;
	
	u.insert(b);
	
	if(is_ok(b))
	{
		check_ans(b);
		
		return;
	}
	
	f(i, N) if(b[i] && ((c[i] & b) != b)) rec(c[i] & b);
}

void Solve()
{
	DFS(0);
	
	srand(12345678);
	
	while(1) rec(c[rand() % N]);
}

int main()
{
	Read();
	
	Solve();
	
	
	return 0;
}
