#include <cstdio>
#include <algorithm>
#include <cmath>
using namespace std;

const int MAXN = 128;

#define pdd pair<double,double>
#define mp make_pair

int n , m;
pdd a[MAXN];
pdd b[MAXN];
pdd ans1;
pdd ans2;

void read() {
    int i;
    double x , y;
    
    scanf ("%d",&n);
    for (i=1;i<=n;i++) {
        scanf ("%lf%lf",&x,&y);
        a[i] = mp ( x , y );
    }
    
    scanf ("%d",&m);
    for (i=1;i<=m;i++) {
        scanf ("%lf%lf",&x,&y);
        b[i] = mp ( x , y );
    }
}

double cross ( pdd a , pdd b , pdd c ) {
    return (b.first-a.first)*(c.second-a.second) - (b.second-a.second)*(c.first-a.first);
}

double dist ( pdd a , pdd b ) {
    return sqrt ( (a.first-b.first)*(a.first-b.first) + (a.second-b.second)*(a.second-b.second) );
}

int cmp ( pdd q , pdd w ) {
    return (int)cross ( a[1] , q , w ) > 0;
}

int calc ( pdd q , pdd w ) {
    int i;
    int ans = 0;
    double cr;
    
    for (i=1;i<=m;i++) {
        cr = cross ( q , w , b[i] );
        if ( fabs ( cr ) < 1e-5 ) return -1;
        if ( cr > 1e-5 ) ++ ans;
    }
    
    return ans;
}

int check ( pdd a , pdd b , pdd c , pdd d ) {
    double d1 , d2;
    double l1 , r1 , l2 , r2;
    double px1 , py1 , px2 , py2;
    double mid1 , mid2;
    int up;
    
    d1 = dist ( a , b );
    d2 = dist ( c , d );
    
    l1 = 0;
    r1 = d2;
    
    while ( (r1 - l1) > 0.00001 ) {
        mid1 = (l1+r1) / 2.;
        px1 = a.first + ((b.first - a.first)/d1) * mid1;
        py1 = a.second + ((b.second - a.second)/d2) * mid1;
        
        l2 = 0.;
        r2 = d2;
        
        while ( (r2 - l2) > 0.00001 ) {
            mid2 = (l2+r2) / 2.;
            
            px2 = d.first + ((d.first - c.first)/d1) * mid2;
            py2 = c.second + ((d.second - c.second)/d2) * mid2;
            
            up = calc ( mp ( px1 , py1 ) , mp ( px2 , py2 ) );
            
            if ( up == -1 ) {
                l2 += 1e-4;
                continue;
            }
            
            if ( up == m/2 ) {
                ans1 = mp ( px1 , py1 );
                ans2 = mp ( px2 , py2 );
                return 1;
            }
            
            if ( up > m/2 )
                r2 = mid2;
            else
                l2 = mid2;
        }
        
        if ( fabs ( l2 ) < 1e-4 )
            r1 = mid1;
        else
            l1 = mid2;
    }
    
    return 0;
}

void solve() {
    pdd sm;
    int idx;
    int i;
    int next;
    double v1 , v2;
    
    sm = mp ( 1<<30 , 1<<30 );
    
    for (i=1;i<=n;i++)
        if ( a[i].first < sm.first || ( a[i].first == sm.first && a[i].second < sm.second ) ) {
            sm = a[i];
            idx = i;
        }
            
    swap ( a[1] , a[idx] );
    
    sort ( a + 2 , a + n + 1 , cmp );
    
    for (i=1;i<=n;i++) {
        next = i + (n/2);
        if ( next > n ) next -= n;
        if ( check ( a[i] , a[(i==n)?1:(i+1)] , a[next] , a[(next==n)?1:(next+1)] ) )
            break;
    }
    
    if ( i == n + 1 )
        printf ("0 0 0 0\n");
    else {
        v1 = (ans2.first - ans1.first);
        v2 = (ans2.second - ans1.second);
        
        while ( 1 ) {
            if ( fabs ( v1 ) < 1.0001 && fabs ( v2 ) < 1.00001 ) break;
            v1 /= 10;
            v2 /= 10;
        }
        
        printf ("%lf %lf %lf %lf\n",ans1.first,ans1.second,v1,v2);
    }
}

int main() {
    read();
    solve();
    
    return 0;
}
