/*
TASK:square
LANG:C++
*/

#include <cstdio>
#include <set>
using namespace std;

#define length						first
#define node						second

const int MAX_N = 1 << 10;
const int INF = 1 << 20;

typedef pair<int, int> PII;

typedef struct square
{
	int Ax, Ay, Cx, Cy;
};


int N;
square s[MAX_N];
int a[MAX_N][MAX_N];
int size[MAX_N], dist[MAX_N];
bool used[MAX_N];
set<PII> heap;
int ans;

void Read()
{
	scanf("%d", &N);
	
	for(int i = 0; i < N; i ++)
	{
		int Mx, My, Ex, Ey;
		
		scanf("%d %d %d %d", &Mx, &My, &Ex, &Ey);
		
		if(Mx < Ex && My < Ey)
		{
			s[i].Cx = Ex;
			s[i].Cy = Ey;
			s[i].Ax = 2 * Mx - Ex;
			s[i].Ay = 2 * My - Ey;
		}
		
		if(Mx < Ex && Ey < My)
		{
			s[i].Cx = Ex;
			s[i].Cy = 2 * My - Ey;
			s[i].Ax = 2 * Mx - Ex;
			s[i].Ay = Ey;
		}
		
		if(Ex < Mx && Ey < My)
		{
			s[i].Ax = Ex;
			s[i].Ay = Ey;
			s[i].Cx = 2 * Mx - Ex;
			s[i].Cy = 2 * My - Ey;
		}
		
		if(Ex < Mx && My < Ey)
		{
			s[i].Ax = Ex;
			s[i].Ay = 2 * My - Ey;
			s[i].Cx = 2 * Mx - Ex;
			s[i].Cy = Ey;
		}
	}
}

bool middle(int _a, int _b, int _c)
{
	if(_a < _b && _b < _c) return true;
	
	return false;
}

bool overlap(int i, int j)
{
	if(middle(s[i].Ax, s[j].Ax, s[i].Cx) && middle(s[i].Ay, s[j].Ay, s[i].Cy)) return true;
	
	if(middle(s[i].Ax, s[j].Cx, s[i].Cx) && middle(s[i].Ay, s[j].Ay, s[i].Cy)) return true;
	
	if(middle(s[i].Ax, s[j].Cx, s[i].Cx) && middle(s[i].Ay, s[j].Cy, s[i].Cy)) return true;
	
	if(middle(s[i].Ax, s[j].Ax, s[i].Cx) && middle(s[i].Ay, s[j].Cy, s[i].Cy)) return true;
	
	if(s[i].Ax == s[j].Ax && s[i].Ay == s[j].Ay && s[i].Cx == s[j].Cx && s[i].Cy == s[j].Cy) return true;
	
	if(s[i].Cy == s[j].Cy || s[i].Ay == s[j].Ay)
	{
		if(s[j].Ax < s[i].Ax && s[i].Cx < s[j].Cx) return true;
		
		if(middle(s[i].Ax, s[j].Ax, s[i].Cx)) return true;
		
		if(middle(s[i].Ax, s[j].Cx, s[i].Cx)) return true;
	}
	
	if(s[i].Ax == s[j].Ax || s[i].Cx == s[j].Cx)
	{
		if(s[j].Cy < s[i].Cy && s[i].Ay < s[j].Ay) return true;
		
		if(middle(s[i].Ay, s[j].Ay, s[i].Cy)) return true;
		
		if(middle(s[i].Ay, s[j].Cy, s[i].Cy)) return true;
	}
	
	return false;
}

void Dijkstra()
{
	for(int i = 1; i < N; i ++) dist[i] = INF;
	
	heap.insert(PII(0, 0));
	
	while(!heap.empty())
	{
		int length = (* heap.begin()).length;
		int node = (* heap.begin()).node;
		
		heap.erase(* heap.begin());
		used[node] = true;
		
		for(int i = 0; i < size[node]; i ++)
		{
			int next = a[node][i];
			
			if(used[next]) continue;
			
			if(length + 1 < dist[next])
			{
				heap.erase(PII(dist[next], next));
				
				dist[next] = length + 1;
				
				heap.insert(PII(dist[next], next));
			}
		}
	}
}

void Solve()
{
	for(int i = 0; i < N; i ++)
	{
		for(int j = i + 1; j < N; j ++)
		{
			if(overlap(i, j) || overlap(j, i))
			{
				a[i][size[i] ++] = j;
				a[j][size[j] ++] = i;
			}
		}
	}
	
	Dijkstra();
	
	ans = dist[N - 1];
	
	if(ans == INF) ans = - 1;
}

void Write()
{
	printf("%d\n", ans);
	
//	getchar();
//	getchar();
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	return 0;
}
/*
3
0 0 1 1
1 0 2 1
4 0 7 2

2
0 0 1 1
4 0 7 2

*/
