/*
TASK:square
LANG:C++
*/
#include <list>
#include <ctime>
#include <functional>
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <sstream>
#include <string>
#include <vector>
#include <bitset>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <utility>
#include <queue>

using namespace std;

#define MP make_pair
#define x first
#define y second
#define PB push_back
#define ALL(v) (v).begin(),(v).end()
#define VI vector<int>
#define PQ priority_queue
#define VD vector<double>
#define LL long long
#define UI unsigned int
#define SZ size()
#define PD pair<double,double>
#define PI pair<int,int>
#define ULL unsigned long long
#define IT iterator
#define sign(x) (((x)>0)-((x)<0))
#define ABS(x) (((x)>0)?(x):(-(x)))
#define sqr(x) ((x)*(x))
#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define pause system("pause")
#define INF 1000000000

int N,M,K,n,m;

struct square{
       PI A,B,C,D,center; LL area2;
       square(){};
       square(PI a,PI b,PI c,PI d){A=a,B=b,C=c,D=d;};
       };
square a[1024];
VI adj[1024];

inline int cp(PI &A,PI &B,PI &C) //&
{
    int dx1=B.x-A.x;
    int dy1=B.y-A.y;
    int dx2=C.x-A.x;
    int dy2=C.y-A.y;
    return dx1*dy2-dx2*dy1;
}

inline bool samearea(PI &X,square &a)
{       return (LL)abs(cp(a.A,a.B,X))+(LL)abs(cp(a.B,a.C,X))+(LL)abs(cp(a.C,a.D,X))+(LL)abs(cp(a.D,a.A,X))==a.area2; }

inline bool isin(PI &X,square &a)
{
       return (sign(cp(a.A,a.B,X)) == sign(cp(a.B,a.C,X))) && 
              (sign(cp(a.C,a.D,X)) == sign(cp(a.B,a.C,X))) &&
              (sign(cp(a.C,a.D,X)) == sign(cp(a.D,a.A,X))) &&
              samearea(X,a);
}

inline bool sqsq(square &a,square &b) //square a has vertex in square b?
{  return (isin(a.A,b) || isin(a.B,b) || isin(a.C,b) || isin(a.D,b));   }


inline bool isin1(PI &A,PI &B,square &a) //A is on a, B is on a, but AB is not on a's edges
{
       int p1=0,p2=0;

       if (cp(a.A,a.B,A)==0) p1|=1;
       if (cp(a.B,a.C,A)==0) p1|=2;
       if (cp(a.C,a.D,A)==0) p1|=4;
       if (cp(a.D,a.A,A)==0) p1|=8;
       
       if (cp(a.A,a.B,B)==0) p2|=1;
       if (cp(a.B,a.C,B)==0) p2|=2;
       if (cp(a.C,a.D,B)==0) p2|=4;
       if (cp(a.D,a.A,B)==0) p2|=8;
       
       //cout<<"               "<<A.x<<" "<<A.y<<" ; "<<B.x<<" "<<B.y<<" == "<<p1<<" "<<p2<<endl;
       return (p1 && p2 && !(p1&p2) && samearea(A,a) && samearea(B,a));
}

inline bool sqsq1(square &a,square &b) //square a has edge with vertices on edges of b & the edge is inside b
{
       return isin1(a.A,a.B,b) || isin1(a.B,a.C,b) || isin1(a.C,a.D,b) || isin1(a.D,a.A,b);
}

bool operator==(const square &a,const square &b)
{
     return (a.A==b.A || a.B==b.A || a.C==b.A || a.D==b.A) && a.center==b.center;
}

int main()
{
    scanf("%d",&N);
    PI C,d;
    Repi(N)
     {
           scanf("%d%d%d%d",&C.x,&C.y,&a[i].A.x,&a[i].A.y);
           d.x=a[i].A.x-C.x,d.y=a[i].A.y-C.y;
           a[i]=square(MP(C.x+d.x,C.y+d.y)
                      ,MP(C.x-d.y,C.y+d.x),
                       MP(C.x-d.x,C.y-d.y),
                       MP(C.x+d.y,C.y-d.x));
           a[i].center=C;
           a[i].area2=(LL)abs(cp(a[i].A,a[i].B,a[i].C)+(LL)cp(a[i].C,a[i].D,a[i].A));
           //cout<<a[i].area2<<endl;
           /*cout<<i<<" - "<<a[i].A.x<<" "<<a[i].A.y<<" ; "
                         <<a[i].B.x<<" "<<a[i].B.y<<" ; "
                         <<a[i].C.x<<" "<<a[i].C.y<<" ; "
                         <<a[i].D.x<<" "<<a[i].D.y<<"\n";*/
    }
    
    Repi(N)   
     Repj(i)
      {
      //cout<<"testing "<<i+1<<" "<<j+1<<endl;
      //cout<<sqsq(a[i],a[j])<<" "<<sqsq(a[j],a[i])<<" "<<sqsq1(a[i],a[j])<<" "<<sqsq1(a[j],a[i])<<endl;
      if (a[i]==a[j] || sqsq(a[i],a[j]) || sqsq(a[j],a[i]) || sqsq1(a[i],a[j]) || sqsq1(a[j],a[i]))
       {
                          adj[j].PB(i);
                          adj[i].PB(j);
                         // cout<<i+1<<" -> "<<j+1<<endl;
       }
      }
      
    int dd[1024],q[1024];
    memset(dd,255,sizeof(dd));
    q[0]=0; dd[0]=0;
    for (int s=0,e=1;s<e;s++)
     {
             int v=q[s];
             Repi(adj[v].SZ)
              {
                int w=adj[v][i];
                if (dd[w]==-1)
                 {
                             dd[w]=dd[v]+1;
                             q[e++]=w;
                             if (w==N-1) break;
                 }
              }
             if (dd[N-1]>-1) break;
     }
    
    printf("%d\n",dd[N-1]);
    
    return 0;
}                                                                                                                                     
