
/*
TASK: lucky
LANG: C++
*/

#include <map>
#include <iostream>
using namespace std;

struct State {
    int s;
    long long p;
    bool any;
    bool equal;
    
    State(int s, long long p, bool any, bool equal) {
        this->s = s;
        this->p = p;
        this->any = any;
        this->equal = equal;
    }
    
    bool operator<(const State &other) const {
        if (s != other.s)
            return s < other.s;
        if (p != other.p)
            return p < other.p;
        if (any != other.any)
            return any < other.any;
        return equal < other.equal;
    }
};

int cur;
long long z;
long long p10[32];
map <State, long long> got[16];

long long count(int digs, State s) {
    if (got[digs].count(s))
        return got[digs][s];
    if (digs == 0) {
        return (s.p % s.s == 0 && s.any ? 1 : 0);
    }
    long long res = 0;
    for (int i = (s.any ? 0 : 1); i <= 9; ++i) {
        if (s.equal) {
            if ((z / p10[digs - 1]) % 10 == i) {
                res += count(digs - 1, State(s.s + i, s.p * i, true, true));
                goto ready;
            } else
                res += count(digs - 1, State(s.s + i, s.p * i, true, false));
        } else {
            res += count(digs - 1, State(s.s + i, s.p * i, true, false));
        }
    }
    ready: ;
    return got[digs][s] = res;
}
long long solve(long long bound) {
    z = bound;
//    for (int i = 0; i < 16; ++i)
//        got[i].clear();
    long long res = 0;
    if (bound == 0)
        return 0;
    for (int i = 1; ; ++i) {
        cur = i;
        if (p10[i] > bound)
            res += count(i, State(0, 1, false, true));
        else
            res += count(i, State(0, 1, false, false));
        if (p10[i] > bound)
            break;
    }
    return res;
}
int main() {
    long long a, b;
    cin >> a >> b;
    p10[0] = 1;
    for (int i = 1; i < 32; ++i)
        p10[i] = p10[i - 1] * 10;
    cout << solve(b) - solve(a - 1) << endl;
    return 0;
}
