/*
TASK:bloxorz
LANG:C++
*/

#include <cstdio>
using namespace std;

const int MAX_N = 32;

struct pos {
	int p, x, y;
	pos () {}
	pos (int _p, int _x, int _y) : p(_p), x(_x), y(_y) {}
};

int n, m;
char S[MAX_N][MAX_N];
int V[3][MAX_N][MAX_N];    // [ one/two_horizontal/two_vertical ][ x ][ y ]
pos path[3][MAX_N][MAX_N];

pos Q[3*MAX_N*MAX_N], c;
int f=0, l=0;
	
pos start, finish;

void input ()
{
	int i, j;
	
	scanf ("%d%d", &n, &m);
	
	for (i=1; i<=n; i++) {
		scanf ("%s", S[i]+1);
		
		for (j=1; j<=m; j++) {
			if (S[i][j]=='S') { start=pos(0,i,j); S[i][j]='.'; }
			if (S[i][j]=='E') { finish=pos(0,i,j); S[i][j]='.'; }
			if (S[i][j]=='K') { S[i][j]='.'; }
			if (S[i][j]>='0' && S[i][j]<='9') { S[i][j]='.'; }
		}
	}
}

inline void insert (pos nc)
{
	if (!V[nc.p][nc.x][nc.y]) {
		//printf ("push: %d %d %d\n", nc.p, nc.x, nc.y);
		
		Q[l++] = nc;
		V[nc.p][nc.x][nc.y] = V[c.p][c.x][c.y] + 1;
		path[nc.p][nc.x][nc.y] = c;
	}
}

void bfs ()
{	
	Q[l++] = start;
	V[start.p][start.x][start.y] = 1;
	
	while (f<l) {
		c = Q[f++];
		//printf ("pop: %d %d %d\n", c.p, c.x, c.y);
		
		if (c.p==0) { // one square
			// to two horizontal
			if (c.y-2>=1) if (S[c.x][c.y-2]!='_' && S[c.x][c.y-1]!='_') insert ( pos(1,c.x,c.y-2) );
			if (c.y+2<=m) if (S[c.x][c.y+2]!='_' && S[c.x][c.y+1]!='_') insert ( pos(1,c.x,c.y+1) );
			
			// to two vertical
			if (c.x-2>=1) if (S[c.x-2][c.y]!='_' && S[c.x-1][c.y]!='_') insert ( pos(2,c.x-2,c.y) );
			if (c.x+2<=n) if (S[c.x+2][c.y]!='_' && S[c.x+1][c.y]!='_') insert ( pos(2,c.x+1,c.y) );

		} else if (c.p==1) { //two horizontal squares
			// to one
			if (c.y-1>=1) if (S[c.x][c.y-1]=='.') insert ( pos(0,c.x,c.y-1) );
			if (c.y+2<=m) if (S[c.x][c.y+2]=='.') insert ( pos(0,c.x,c.y+2) );
			
			// to two horizontal
			if (c.x-1>=1) if (S[c.x-1][c.y]!='_' && S[c.x-1][c.y+1]!='_') insert ( pos(1,c.x-1,c.y) );
			if (c.x+1<=n) if (S[c.x+1][c.y]!='_' && S[c.x+1][c.y+1]!='_') insert ( pos(1,c.x+1,c.y) );
		} else { // two vertical squares
			// to one
			if (c.x-1>=1) if (S[c.x-1][c.y]=='.') insert ( pos(0,c.x-1,c.y) );
			if (c.x+2<=n) if (S[c.x+2][c.y]=='.') insert ( pos(0,c.x+2,c.y) );
			
			// to two vertical
			if (c.y-1>=1) if (S[c.x][c.y-1]!='_' && S[c.x+1][c.y-1]!='_') insert ( pos(2,c.x,c.y-1) );
			if (c.y+1<=m) if (S[c.x][c.y+1]!='_' && S[c.x+1][c.y+1]!='_') insert ( pos(2,c.x,c.y+1) );
		} 
	}
}

void rec (pos q)
{
	if (q.p==start.p && q.x==start.x && q.y==start.y) return;
	pos w = path[q.p][q.x][q.y];
	rec (w);
   
	if (w.y>q.y) printf ("l");
	if (w.y<q.y) printf ("r");
	if (w.x>q.x) printf ("u");
	if (w.x<q.x) printf ("d");
}

void output ()
{
	if (!V[finish.p][finish.x][finish.y]) printf ("0\n");
	else {
		printf ("%d\n", V[finish.p][finish.x][finish.y]-1);
		rec (finish);
		printf ("\n");
	}
}

int main ()
{
	input ();
	bfs ();
	output ();
	
	return 0;
}
