#include <cstdio>
#include <algorithm>
using namespace std;

const int MAXN = 25;
const int MAXQ = 1 << 20;//3 ^ 12

struct el {
    int x , y , z;
    
    el () { 
        x = y = z = 0;
    }
    el ( int _x , int _y , int _z ) {
        x = _x;
        y = _y;
        z = _z;
    }
    
    int operator < ( el b ) const {
        if ( x != b.x ) return x < b.x;
        if ( y != b.y ) return y < b.y;
        return z < b.z;
    }
};

int n;
int a[MAXN];
el t[MAXQ];

void read() {
    int i;
    
    scanf ("%d",&n);
    for (i=1;i<=n;i++)
        scanf ("%d",&a[i]);
}

int solve() {
    int i , j;
    int e , r , pow1 , pow2;
    int sum , big;
    int x , y;
    el cur , f;
    int need;
    int lo , hi;
    int mid;
    
    sum = 0;
    big = 0;
    
    for (i=1;i<=n;i++) {
        if ( big < a[i] ) big = a[i];
        sum += a[i];
    }
    
    if ( sum % 3 || big > sum / 3 || n < 3 ) 
        return 0;
    need = sum / 3;
        
    e = (n + 1) / 2;
    pow1 = 1;
    for (i=1;i<=e;i++) pow1 *= 3;
    
    for (i=0;i<pow1;i++) {
        x = i;
        for (j=1;j<=e;j++) {
            y = x % 3;
            x /= 3;
            
            if ( y == 0 ) t[i].x += a[j];
            if ( y == 1 ) t[i].y += a[j];
            if ( y == 2 ) t[i].z += a[j];
        }
    }
    
    sort ( t , t + pow1 );
        
    r = n / 2;
    pow2 = 1;
    for (i=1;i<=r;i++) pow2 *= 3;
    
    for (i=0;i<pow2;i++) {
        x = i;
        
        cur.x = cur.y = cur.z = 0;
        for (j=e + 1;j<=n;j++) {
            y = x % 3;
            x /= 3;
            
            if ( y == 0 ) cur.x += a[j];
            if ( y == 1 ) cur.y += a[j];
            if ( y == 2 ) cur.z += a[j];
        }
        cur.x = need - cur.x;
        cur.y = need - cur.y;
        cur.z = need - cur.z;
        
        lo = 0;
        hi = pow1;
        
        while ( lo < hi ) {
            mid = (lo + hi) / 2;
            
            if ( t[mid].x == cur.x && t[mid].y == cur.y && t[mid].z == cur.z ) return 1;
            
            if ( t[mid].x == cur.x ) {
                if ( t[mid].y == cur.y ) {
                    if ( t[mid].z < cur.z )
                        lo = mid + 1;
                    else
                        hi = mid - 1;
                } else {
                    if ( t[mid].y < cur.y )
                        lo = mid + 1;
                    else
                        hi = mid - 1;
                }
            } else {
                if ( t[mid].x < cur.x )
                    lo = mid + 1;
                else
                    hi = mid - 1;
            }
        }
    }
    
    return 0;
}

int main() {
    read();
    printf ( "%d\n" , solve() );
    
    return 0;
}
