#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <queue>
#include <ctime>

using namespace std;

#define MAXN 1024
#define SOURCE 0
#define SINK 513
#define INF INT_MAX/2

#define min(a,b) ((a)<(b)?(a):(b))

int g[MAXN][MAXN];
int N, M;
int dist[MAXN];
int path[MAXN];
int pos;
bool used[MAXN];
queue <int> q;
int all = 0;
int start;

bool bfs(void) {
    
    memset(dist, 0, sizeof(dist));
    dist[SINK] = 1;
    q.push(SINK);
    
    int cnode;
    
    while (!q.empty()) {
        cnode = q.front();
        q.pop();
        
        if (cnode == SOURCE) {
            for (int i = 1; i <= N; i++) {
                if (g[i][cnode] > 0 && dist[i] == 0) {
                    dist[i] = dist[cnode] + 1;
                    q.push(i);
                }
            }
        }
        
        if (cnode == SINK) {
            for (int i = N + 1; i <= N + M; i++) {
                if (g[i][cnode] > 0 && dist[i] == 0) {
                    dist[i] = dist[cnode] + 1;
                    q.push(i);
                }
            }
        }
        
        if (cnode > SOURCE && cnode <= N) {
            if (g[SOURCE][cnode] > 0 && dist[SOURCE] == 0) {
                dist[SOURCE] = dist[cnode] + 1;
                q.push(SOURCE);
            }
            for (int i = N + 1; i <= N + M; i++) {
                if (g[i][cnode] > 0 && dist[i] == 0) {
                    dist[i] = dist[cnode] + 1;
                    q.push(i);
                }
            }
        }
        
        if (cnode > N && cnode <= N + M) {
            for (int i = 1; i <= N; i++) {
                if (g[i][cnode] > 0 && dist[i] == 0) {
                    dist[i] = dist[cnode] + 1;
                    q.push(i);
                }
            }
        }
        
    }
    
    if (dist[SOURCE] == 0) {
        return false;
    }
    return true;
}

int dfs(int node) {
    
    if (node == SINK) {
        pos = 0;
        path[pos++] = SINK;
        return INF;
    }
    
    used[node] = true;
    
    if (node == SOURCE) {
        for (int i = 1; i <= N; i++) {
            if (g[node][i] > 0 && dist[i] == dist[node] - 1 && !used[i]) {
                int temp  = dfs(i);
                if (temp > 0) {
                    path[pos++] = node;
                    return min(temp, g[node][i]);
                }
            }
        }
    }
    
    if (node > SOURCE && node <= N) {
        for (int i = N + 1; i <= N + M; i++) {
            if (g[node][i] > 0 && dist[i] == dist[node] - 1 && !used[i]) {
                int temp  = dfs(i);
                if (temp > 0) {
                    path[pos++] = node;
                    return min(temp, g[node][i]);
                }
            }
        }
    }    
    
    if (node > N && node <= N + M) {
        if (g[node][SINK] > 0 && dist[SINK] == dist[node] - 1) {
            int temp = dfs(SINK);
            if (temp > 0) {
                path[pos++] = node;
                return min(g[node][SINK], temp);
            }
        }
        for (int i = 1; i <= N; i++) {
            if (g[node][i] > 0 && dist[i] == dist[node] - 1 && !used[i]) {
                int temp  = dfs(i);
                if (temp > 0) {
                    path[pos++] = node;
                    return min(temp, g[node][i]);
                }
            }
        }
    }
    
    return 0;
}

int maxflow() {
    int ans = 0;
    int temp;
    while (bfs()) {
        if (((double)(clock()-start))/CLOCKS_PER_SEC > 5.0) {
            return 0;
        }
        memset(used, false, sizeof(used));
        while (temp = dfs(SOURCE)) {
            used[SOURCE] = false;
            ans += temp;
            pos--;
            while (pos > 0) {
                g[path[pos]][path[pos-1]] -= temp;
                g[path[pos-1]][path[pos]] += temp;
                pos--;
            }
        }
    }
    return ans;
}

int main() {
    
    start = clock();
    scanf("%d%d", &M, &N);
    
    int temp, tempb;
    
    for (int i = 1; i <= M; i++) {
        scanf("%d", &temp);
        g[N+i][SINK] = temp;
        all += temp;
    }
    
    for (int i = 1; i <= N; i++) {
        scanf("%d", &temp);
        g[SOURCE][i] = temp;
        scanf("%d", &temp);
        for (int j = 0; j < temp; j++) {
            scanf("%d", &tempb);
            g[i][N + tempb] = INT_MAX;
        }
    }
    
    if (all == maxflow()) {
        printf("Yes\n");
    }
    else {
        printf("No\n");
    }
    
    return 0;
}
