#include <stdio.h>
#include <string>
#include <queue>
using namespace std;

struct Vertex
{
	int u, next, cap;
	Vertex(int _u, int _cap, int _next):u(_u), cap(_cap), next(_next){}
	Vertex(){}
} nodes[2*(256*256 + 2*256)];
int cnt;
int table[1024];
int N, K;

void add(int a, int b, int cap)
{
	nodes[cnt] = Vertex(b, cap, table[a]);
	table[a] = cnt++;
	
	nodes[cnt] = Vertex(a, 0, table[b]);
	table[b] = cnt++;
}

int C[2*256+2];
int DFS(int k, int *path, int pos)
{
	if (k == N + K + 1) return pos;
	
	for (int v = table[k]; v != -1; v = nodes[v].next) 
	 if (nodes[v].cap > 0 && C[k] > C[nodes[v].u])
	 { 
	 	path[pos] = v;
	 	int ret;
		if ((ret = DFS( nodes[v].u, path, pos + 1)) != 0) return ret;
	 }
	 return 0;
}

bool BFS()
{
	queue<pair<int, int> > q;
	q.push(make_pair(N + K + 1, 1));
	C[N+K+1] = 1;
	
	while (!q.empty())
	{
		int k = q.front().first;
		int lvl = q.front().second;
		q.pop();
		
		if (k == 0) return 1;
		
		for (int v = table[k]; v != -1; v = nodes[v].next) 
		 if (nodes[v^1].cap > 0 && C[nodes[v].u] == 0)
		 {
			C[nodes[v].u] = lvl + 1;
			q.push(make_pair(nodes[v].u, lvl + 1));
		 }
	}
	return 0;
}

int FLOODIT()
{
	int path[2*256+10], sz, f = 0;
	
	while (BFS() != 0)
	{
	    while (sz = DFS(0, path, 0))
	    {
		    int minn = 1000000000+1;
		    for (int i = 0; i < sz; i++)
		     minn = min(minn, nodes[ path[i] ].cap);
		
		    for (int i = 0; i < sz; i++)
		     nodes[ path[i]   ].cap -= minn,
		     nodes[ path[i]^1 ].cap += minn;
		
		    f += minn;
	    }
	    memset(C, 0, sizeof(C));
	} 
	
	return f;
}

int main()
{
	memset(table, -1, sizeof(table));
	scanf("%d%d", &N, &K);
	
	int sum = 0;
	for (int i = 1; i <= K; i++)
	{
		int v;
		scanf("%d", &v);
		sum += v;
		add(N + i, N + K + 1, v);
	}
	for (int i = 1; i <= N; i++)
	{
		int b, c;
		scanf("%d%d", &b, &c);
		
		add(0, i, b);
		for (int j = 0; j < c; j++) 
	    {
			int v;
			scanf("%d", &v);
			add(i, N + v, b);
		}
	}  
	if (FLOODIT() == sum) printf("Yes\n");
	else                  printf("No\n");
	
 	/*for (int i = 0; i <= N + K + 1; i++)
	{
		printf("%d: ", i);
		for (int v = table[i]; v != -1; v = nodes[v].next) if (v%2 == 0)
		 printf("%d( %d ) ", nodes[v].u, nodes[v].cap);
		printf("\n");
	}*/
	
	return 0;
}
