#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int MAX_N = 100000+50;
const int INF   = int(2e9) + 100;

int n;
int A[MAX_N];

void input ()
{
	int i;

	scanf ("%d", &n);

	for (i=0; i<n; i++)
		scanf ("%d", &A[i]);

	sort (A,A+n);
}

void dummy ()
{
	vector<int> V;
	int i, j;
	int ans_dist=INF, ans_med;

	for (i=n-1; i>=0; i--) {
		V.clear ();

		for (j=0; j<n; j++)
			if (i!=j)
				V.push_back ( abs(A[j]-A[i]) );

		sort (V.begin(), V.end());

		if (V[n/2-1] < ans_dist) {
			ans_dist = V[n/2-1];
			ans_med = A[i];
		}
	}

	//printf ("dummy solve: ans_med=%d  ans_dist=%d\n", ans_med, ans_dist);
	printf ("%d\n", ans_med);
}

// how many distances are not higher than 'dist' in [lo,up]
int BS_count_lower_bound (int lo, int up, int downhill, int dist, int m)
{
	int mid;
	if (lo>up) return 0;

	if (downhill==1) {
		lo--;
		while (lo+1<up) {
			mid = lo + (up-lo)/2;
			if ( abs(A[mid]-A[m]) <= dist ) up=mid;
			else lo=mid;
		}

		if ( abs(A[up]-A[m]) > dist ) return 0;
		return m-up;
	}
	else {
		up++;
		while (lo+1<up) {
			mid = lo + (up-lo)/2;
			if ( abs(A[mid]-A[m]) > dist ) up=mid;
			else lo=mid;
		}

		if ( abs(A[lo]-A[m]) > dist ) return 0;
		return lo-m;
	}
}

// what is the distance between the mediatron and the median of the remaining distances
int BS_dist (int m)
{
	int lo=-1, up=INF, dist;

	while (lo+1<up) {
		dist = lo + (up-lo)/2;

		if ( BS_count_lower_bound (0,m-1,1,dist,m) + BS_count_lower_bound (m+1,n-1,-1,dist,m) >= n/2) up=dist;
		else lo=dist;
	}

	return up;
}

void solve ()
{
	int m, d;
	int ans_dist=INF, ans_med;

	for (m=n-1; m>=0; m--)
		if ( (d=BS_dist(m)) < ans_dist ) {
			ans_dist = d;
			ans_med = A[m];
		}

	//printf ("real solve:  ans_med=%d  ans_dist=%d\n", ans_med, ans_dist);
	printf ("%d\n", ans_med);
}

int main ()
{
	//freopen ("mediatron.in", "r", stdin);

	input ();
	
	if (n<=2000) dummy ();
	else solve ();

	return 0;
}