/*
TASK: xerxes
NAME: Petar Ivanov
*/

#include <cstdio>
#include <memory.h>

const int MAX_N = 600;
const int MAX_M = 300 * 300 * 2;
const int INF   = int(2e9);

struct edge {
	int to, rd, next;
	edge () {}
	edge (int _to, int _rd, int _next) : to(_to), rd(_rd), next(_next) {}
};

int n, k, soldiers=0;
int vec[MAX_N], last=0;
edge buf[MAX_M];

int D[MAX_N];

int source, sink, ans=0;

inline int min (int a, int b) { return a<b?a:b; }

void add (int from, int to, int val)
{
	buf[last] = edge(to,val,vec[from]);
	vec[from] = last++;
	buf[last] = edge(from,0,vec[to]);
	vec[to]   = last++;
}

void input ()
{
	int i, j, a;

	scanf ("%d%d", &n, &k);

	source = 0;
	sink = n+k+1;

	memset (vec,-1,sizeof(vec));

	for (i=k+1; i<=k+n; i++) {
		scanf ("%d", &a);
		add (i,sink,a);
		soldiers += a;
	}

	for (i=1; i<=k; i++) {
		scanf ("%d%d", &a, &j);
		add (source,i,a);

		while (j--) {
			scanf ("%d", &a);
			add (i,k+a,INF);
		}
	}

	/*
	for (i=0; i<=k+n+1; i++) {
		printf ("%d:", i);
		
		for (j=vec[i]; j!=-1; j=buf[j].next)
			printf (" (%d,%d)", buf[j].to, buf[j].rd);

		printf ("\n");
	}
	*/
}

bool bfs ()
{
	static int Q[MAX_N];
	int i, p, f=0, l=0;

	memset (D,0,sizeof(D));

	Q[l++] = sink;
	D[sink] = 1;

	while (f<l) {
		p = Q[f++];
		for (i=vec[p]; i!=-1; i=buf[i].next)
			if (!D[ buf[i].to ] && buf[i^1].rd) {
				D[ buf[i].to ] = D[p] + 1;
				Q[l++] = buf[i].to;
			}
	}

	return D[source];
}

int dfs (int p, int f)
{
	if (p==sink) return f;

	int i, c;

	for (i=vec[p]; i!=-1; i=buf[i].next)
		if (D[ buf[i].to ]+1==D[p] && buf[i].rd) {
			if ( c=dfs( buf[i].to, min(f,buf[i].rd) ) ) {
				buf[i  ].rd -= c;
				buf[i^1].rd += c;
				//printf ("%d %d: %d\n", p, buf[i].to, c);
				return c;
			}
		}

	return D[p]=0;
}

void dinitz ()
{
	int f;

	while (bfs())
		while (f=dfs(source,INF))
			ans += f;
}

int main ()
{
	//freopen ("xerxes.in", "r", stdin);

	input ();
	dinitz ();

	printf ("%s\n", ans==soldiers ? "Yes" : "No");

	return 0;
}
