#include <cstdio>
#include <ctime>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 17;

typedef long long ll;

int n;
int a[MAXN];

void read() {
    int i;
    
    scanf ("%d",&n);
    
    for (i=1;i<=n;i++)
        scanf ("%d",&a[i]);
    
    sort ( a + 1 , a + n + 1 );
}

int bsearch ( ll x ) {
    int l , r;
    int mid;
    
    l = 0;
    r = n;
    
    while ( l < r ) {
        mid = l + (r - l + 1) / 2;
        
        if ( (ll)a[mid] > x )
            r = mid - 1;
        else
            l = mid;
    }
    
    return l;
}

ll bsearch2 ( int x ) {
    int l , r;
    int mid;
    ll ans;
    
    l = 0;
    r = x;
    
    while ( l < r ) {
        mid = l + (r - l + 1) / 2;
        
        if ( bsearch ( (ll)a[x] + (ll)a[x] - (ll)a[mid] ) - mid + 1 >= n / 2 + 1 )
            l = mid;
        else
            r = mid - 1;
    }
    if ( l ) ans = (ll)a[x] - (ll)a[l];
    
    l = x;
    r = n + 1;
        
    while ( l < r ) {
        mid = l + (r - l) / 2;
            
        if ( mid - bsearch ( (ll)a[x] + (ll)a[x] - (ll)a[mid] - 1LL ) >= n / 2 + 1 )
            r = mid;
        else
            l = mid + 1;
    }

    if ( r != n + 1 ) 
        ans = min ( ans , (ll)a[l] - (ll)a[x] );
        
    return ans;
}

void solve() {
    int i;
    ll best;
    int ans;
    ll x;
    
    ans = 1 << 30;
    best = 10000000000000LL;
    
    for (i=n;i>=1;i--) {
        x = bsearch2 ( i );
        
        if ( x < best ) {
            best = x;
            ans = a[i];
        }
    }
    
    printf ("%d\n",ans);
}

int main() {
    read();
    solve();
    
    return 0;
}
