#include <cstdio>
#include <algorithm>
#include <vector>
using namespace std;

const int MAXN = 1 << 10;
const int inf = 1 << 30;

struct edge {
    int to;
    int cap;
    
    int revy;
    
    edge () {}
    edge ( int _to , int _cap ) : to ( _to ) , cap ( _cap ) {}
};

int n , k;
int need;

int v;
int source , sink;
vector < edge > a[MAXN];

int d[MAXN];
int used[MAXN];

void make_edge ( int u , int v , int cap ) {
    int s1 = (int)a[u].size();
    int s2 = (int)a[v].size();
    
    a[u].push_back ( edge ( v , cap ) );
    a[v].push_back ( edge ( u , 0 ) );
    a[u][s1].revy = s2;
    a[v][s2].revy = s1;
}

void read() {
    int i , j;
    int x;
    
    scanf ("%d%d",&n,&k);
    
    source = n + k + 1;
    sink = source + 1;
    v = n + k + 2;
    
    for (i=1;i<=n;i++) {
        scanf ("%d",&x);
        
        need += x;
        make_edge ( k + i , sink , x );
    }
    
    for (i=1;i<=k;i++) {
        scanf ("%d",&x);
        make_edge ( source , i , x );
        
        for (scanf("%d",&j);j--;) {
            scanf ("%d",&x);
            make_edge ( i , k + x , inf );
        }
    }
}

int bfs() {
    static int q[MAXN];
    int sz;
    int i , j;
    
    for (i=1;i<=v;i++) {
        used[i] = 0;
        d[i] = -1;
    }
    
    q[ sz = 0 ] = sink;
    d[ sink ] = 0;
    
    for (i=0;i<=sz;i++)
        for (j=0;j<(int)a[ q[i] ].size();j++) 
            if ( d[ a[ q[i] ][j].to ] == -1 && a[ a[ q[i] ][j].to ][ a[ q[i] ][j].revy ].cap ) {
                d[ a[ q[i] ][j].to ] = d[ q[i] ] + 1;
                q[ ++ sz ] = a[ q[i] ][j].to;
            }
            
    return d[source] != -1;
}

int dfs ( int node , int flow ) {
//    printf ("%d   %d\n",node,flow);
    if ( node == sink ) return flow;
    used[node] = 1;
    int i;
    int x;
    
    for (i=0;i<(int)a[node].size();i++)
        if ( !used[ a[node][i].to ] && a[node][i].cap && d[ a[node][i].to ] + 1 == d[ node ] ) {
            x = dfs ( a[node][i].to , min ( flow , a[node][i].cap ) );
            
 //           printf ("go from   %d   to   %d   and returned   %d\n",node,a[node][i].to,x);
            if ( x != -1 ) {
   //             printf ("change    %d %d   %d\n",node,a[node][i].to,x);
                
                a[node][i].cap -= x;
                a[ a[node][i].to ][ a[node][i].revy ].cap += x;
                
                return x;
            }
        }
        
    return -1;
}

int dinitz() {
    int maxflow = 0;
    int flow;
    
    while ( bfs() )
        while ( (flow = dfs( source , inf )) != -1 )
            maxflow += flow;
            
    return maxflow;    
}

void solve() {
    if ( dinitz() == need ) 
        printf ("Yes\n");
    else
        printf ("No\n");
}

int main() {
    read();
    solve();
    
    return 0;
}
