
/*
    FROM: National Olympiad, 2008, K4
    PROB: period
    KEYW: kmp
*/

#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <iostream>
using namespace std;

//int p [40000005]; // MAKE THIS MEMORY DYNAMIC!!!
int *p;
char str [40000005];

void input ()
{
    gets (str);
}
int solve ()
{
    int n = 0;
    while (str [n]) ++n;
    int n2 = n + n;
    for (int i = 0; i < n; ++i)
        str [n + i] = str [i];
    str [n2] = 0;
    p = new int [n2 + 16];
    p [0] = p [1] = 0;
    int at;
    for (int i = 2; i <= n2; ++i)
    {
        at = p [i - 1];
        while (at > 0 && str [at] != str [i - 1])
            at = p [at];
        if (str [i - 1] == str [at])
            p [i] = at + 1;
    }
    at = 0;
    for (int j = 1; j <= n2; ++j)
    {
        while (at > 0 && str [j] != str [at])
            at = p [at];
        if (str [at] == str [j])
        {
            ++at;
            if (at == n)
                return j - n + 1;
        }
    }
    return -1;
}

inline int random (int a, int b)
{
    return a + rand () % (b - a + 1);
}
int brute ()
{
    int n = strlen (str);
    for (int i = 1; i <= n; ++i)
        if (n % i == 0)
        {
            bool ok = true;
            for (int j = 0; j < i; ++j)
                for (int k = j; k < n; k += i)
                    if (str [j] != str [k])
                    {
                        ok = false;
                        break;
                    }
            if (ok)
                return i;
        }
    return -1;
}
void testing ()
{
    int t = 0;
    while (true)
    {
        int len = random (100, 4000);
        int ps = random (100, 4000);
        assert (len * ps);
        
        str [len * ps] = 0;
        for (int i = 0; i < len; ++i)
        {
            char ch = '0' + random (0, 9);
            for (int j = i; j < len * ps; j += len)
                str [j] = ch;
        }
        //puts (str);
        int s1 = brute ();
        int s2 = solve ();
        assert (s1 == s2 && s1 > 0);
        //if (n != strlen (str))
        if (s1 == -1)
        {
            puts (str);
            puts ("THIS SHOULDN'T HAVE HAPPENED!");
            return ;
        }
//        if (++t % 100 == 0)
        printf ("%d %d\n", s1, s2);
    }
}
int main ()
{
    //testing ();
    input ();
    printf ("%d\n", solve ());
    return 0;
}
