
/*
    FROM: National Olympiad, 2008, K4
    PROB: xerxes
    KEYW: maxflow
*/

#include <cstdio>
#include <algorithm>
using namespace std;

const int NODES = 32768;
const int EDGES = 524288;

struct edge
{
    int to;
    int cap;
    int prev;
    
    edge ()
    {
    }
    
    edge (int to, int cap, int prev)
    {
        this->to = to;
        this->cap = cap;
        this->prev = prev;
    }
};

int ptr = 0;
int s, t;
int d [NODES];
int q [NODES], p3;
int head [NODES];
edge list [EDGES];

int dfs (int at, int cflow)
{
    if (at == t)
        return cflow;
    int b;
    for (int j = head [at]; j != -1; j = list [j].prev)
        if (d [at] == 1 + d [list [j].to] && list [j].cap > 0)
        {
            b = dfs (list [j].to, min (cflow, list [j].cap));
            if (b > 0)
            {
                list [j].cap -= b;
                list [j ^ 1].cap += b;
//                printf ("%d <- ", list [j].to);
                return b;
            }
            else
                d [list [j].to] = -1;
        }
    return 0;
}
int flow (int n, int s, int t)
{
    ::s = s;
    ::t = t;
    int by;
    int res = 0;
    while (true)
    {
        p3 = 0;
        memset (d, -1, sizeof (int) * n);
        d [t] = 0;
        q [p3 ++] = t;
        for (int i = 0; i < p3; ++i)
            for (int j = head [q [i]]; j != -1; j = list [j].prev)
                if (list [j ^ 1].cap > 0 && d [list [j].to] == -1)
                {
                    d [list [j].to] = d [q [i]] + 1;
                    q [p3 ++] = list [j].to;
                }
//        for (int i = 0; i < n; ++i)
//            printf ("d [%d] = %d\n", i, d [i]);
//        puts ("");    
        if (d [s] == -1)
            break;
        while (true)
        {
            by = dfs (s, 1 << 30);
            if (by == 0)
                break;
//            printf (" by %d\n", by);
            res += by;
        }
    }
    return res;
}
inline void addedge (int u, int v, int cap)
{
    list [ptr] = edge (v, cap, head [u]);
    head [u] = ptr ++;
    
    list [ptr] = edge (u, 0, head [v]);
    head [v] = ptr ++;
}
int main ()
{
    memset (head, -1, sizeof (head));
    int N, K;
    scanf ("%d %d", &N, &K);
    int all = 0;
    int src = K + N;
    int snk = src + 1;
    for (int i = 0; i < N; ++i)
    {
        int am;
        scanf ("%d", &am);
        addedge (K + i, snk, am);
        all += am;
    }
//    printf ("READY SOLDIERS!\n");
    for (int i = 0; i < K; ++i)
    {
        int bi, ci, zi;
        scanf ("%d %d", &bi, &ci);
        addedge (src, i, bi);
        for (int j = 0; j < ci; ++j)
        {
            scanf ("%d", &zi);
            addedge (i, K + zi - 1, 1 << 30);
        }
    }
    int nodes = snk + 1;
/*    for (int i = 0; i < nodes; ++i)
    {
        printf ("%d: ", i);
        for (int j = head [i]; j != -1; j = list [j].prev)
            printf ("(%d, %d), ", list [j].to, list [j].cap);
        puts ("");
    }
    return -1;*/
    int got = flow (snk + 1, src, snk);
    if (got == all)
        puts ("Yes");
    else
        puts ("No");
    return 0;
}
