#include <iostream>
#include <fstream>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <numeric>
#include <utility>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <string>

using namespace std;

#define Repi(n) for (int i=0;i<(n);i++)
#define Repj(n) for (int j=0;j<(n);j++)
#define Repk(n) for (int k=0;k<(n);k++)
#define sign(x) (((x)>0)-((x)<0))
#define PI pair<int,int>
#define PD pair<double,double>
#define MP make_pair
#define LL long long
#define ULL unsigned long long
#define x first
#define y second
#define ALL(v) (v).begin(),(v).end()
#define IT iterator
#define VI vector<int>
#define VD vector<double>
#define PB push_back
#define ABS(x) (((x)>0)?(x):(-(x)))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define pause system("pause")
#define PQ priority_queue
#define INF 2000000000
#define SZ size()

int N,M,n,m,K,all;

#define MAXN 1024
VI adj[MAXN];
int cap[MAXN][MAXN],res[MAXN][MAXN],NN,sink,source;

int a[MAXN],b[MAXN],c[MAXN];

int scalingbfs()
{
    int u,v,flow=0,mincap,q[MAXN],p[MAXN]; bool used[MAXN];
    memcpy(res,cap,sizeof(cap));
    
    p[source]=-1; int delta=INF;
    while(1)
     {
            q[0]=source; memset(used,0,sizeof(used)); used[source]=1;
            for (int s=0,e=1;s<e;s++)
             {
                u=q[s];
                Repi(adj[u].SZ)
                 {
						v=adj[u][i];
						if (used[v] || res[u][v]<delta) continue;
						used[v]=1;
						p[v]=u;
						q[e++]=v;
						if (v==sink) break;
				 }
				if (used[sink]) break;
             }
            if (!used[sink])
             {
					delta/=2;
					if (!delta) return flow;
					continue;
			 }
            
            int pc=0,v=sink;
            while (v>-1) { q[pc++]=v; v=p[v]; }
            reverse(q,q+pc);
            
            mincap=INF;
            Repi(pc-1) mincap=MIN(mincap,res[q[i]][q[i+1]]);
            //cout<<mincap<<" -> "; Repi(pc) cout<<q[i]<<" "; cout<<endl;
            flow+=mincap;
            Repi(pc-1)
             {
					res[q[i]][q[i+1]]-=mincap;
					res[q[i+1]][q[i]]+=mincap;
			 }
     }
}


int pushrelabel()
{
    int next[MAXN],pc,u,v,flow=0,d[MAXN],mincap,q[MAXN],p[MAXN]; bool used[MAXN];
    memcpy(res,cap,sizeof(cap));
    
    d[sink]=0; q[0]=sink; memset(used,0,sizeof(used)); used[sink]=1;
    for (int s=0,e=1;s<e;s++)
     {
			u=q[s];
			Repi(adj[u].SZ)
			 {
			   v=adj[u][i];
			   if (used[v] || !res[v][u]) continue;
			   q[e++]=v;
			   d[v]=d[u]+1;
			   used[v]=1;
			 }
	 }
	
   u=source; p[source]=-1; memset(next,0,sizeof(next));
   while (d[source]<NN)
    {
		for(;next[u]<adj[u].SZ;next[u]++)
		 { v=adj[u][next[u]]; if (res[u][v] && d[u]==d[v]+1) break; }
		if (next[u]==adj[u].SZ)
		 {
				next[u]=0;
				d[u]=INF;
				Repi(adj[u].SZ)
				 {
				  v=adj[u][i];
				  if (res[u][v]) d[u]=MIN(d[u],d[v]+1);
				 }
				if (u!=source) u=p[u];
				continue;
		 }
		p[v]=u;
		u=v;
		if (u==sink)
		 {
				pc=0;
				while(u!=-1) { q[pc++]=u; u=p[u]; }
				reverse(q,q+pc);
				mincap=INF;
				Repi(pc-1) mincap=MIN(mincap,res[q[i]][q[i+1]]);
				flow+=mincap;
				//cout<<mincap<<" ------> "; Repi(pc) cout<<q[i]<<" "; cout<<endl;
                Repi(pc-1)
                  {
					res[q[i]][q[i+1]]-=mincap;
					res[q[i+1]][q[i]]+=mincap;
		       	  }
		       	u=source;
		 }
	}
  return flow;
}


inline void addedge(int u,int v,int capac)
{
	//cout<<"edge "<<u<<" "<<v<<" "<<capac<<endl;
	cap[u][v]=capac; adj[u].PB(v); adj[v].PB(u);
}

int main()
{
    int tmp; all=0;
    scanf("%d%d",&N,&K);
    NN=N+K+3;
    source=0,sink=NN-1;
    
    Repi(N) { scanf("%d",a+i); all+=a[i]; addedge(N+i+1,sink,a[i]); }
    Repi(K)
     {
			scanf("%d%d",b+i,c+i);
			addedge(source,i+1,b[i]);
			Repj(c[i])
			 {
			   scanf("%d",&tmp);
			   addedge(i+1,N+tmp,INF);
			 }
	 }
     
    
   // cout<<scalingbfs()<<endl;
    //cout<<pushrelabel()<<endl;
    
    if (pushrelabel()!=all) printf("No\n");
    else printf("Yes\n");
    
    return 0;
}
