#include <cstdio>
#include <algorithm>
using namespace std;

#define ABS(a)								((a) < (0) ? (- (a)) : (a))

const int MAX_N = 100000;
int EPS;

int N;
int a[MAX_N], b[MAX_N];
int ans;

void Read()
{
	scanf("%d", &N);
	
	for(int i = 0; i < N; i ++)
	{
		scanf("%d", &a[i]);
	}
}

int mediatron(int pos)
{
	for(int i = 0; i < N; i ++)
	{
		if(i < pos) b[i] = ABS(a[i] - a[pos]);
		
		if(pos < i) b[i - 1] = ABS(a[i] - a[pos]);
	}
	
	sort(b, b + N - 1);
	
	return b[(N >> 1) - 1];
}

void Solve()
{
int left, right;
	
	sort(a, a + N);
	
	if(N <= 20000) EPS = 170;
	else EPS = 35;
	
	if(N <= 10000) EPS = 500;
	
	for(left = 0, right = N - 1; left + EPS < right;)
	{
		int left_third = ((left << 1) + right) / 3;
		int right_third = (left + (right << 1)) / 3;
		
		if(mediatron(right_third) <= mediatron(left_third))
		{
			left = left_third;
		}
		else
		{
			right = right_third;
		}
	}
	
	right = min(N - 1, right + EPS);
	left = max(0, left - EPS);
	
	ans = right;
	
	for(int i = right; left<= i; i --)
	{
		if(mediatron(i) < mediatron(ans))
		{
			ans = i;
		}
	}
	
	ans = a[ans];
}

void Write()
{
	printf("%d\n", ans);
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	return 0;
}
