#include <cstdio>

#define min(a, b)							((a) < (b) ? (a) : (b))

const int MAX_N = 550;
const int INF = 2000000000;

int W, G, All_w, All_g;
int capacity[MAX_N][MAX_N];
int q[MAX_N], flow[MAX_N], parent[MAX_N], q_top;
bool used[MAX_N];
bool ans;

void Read()
{
	scanf("%d %d", &W, &G);
	
	for(int i = 1; i <= W; i ++)
	{
		scanf("%d", &capacity[G + i][G + W + 1]);
		
		All_w += capacity[G + i][G + W + 1];
	}
	
	for(int i = 1; i <= G; i ++)
	{
		int c, w;
		
		scanf("%d %d", &capacity[0][i], &c);
		
		All_g += capacity[0][i];
		
		for(int j = 0; j < c; j ++)
		{
			scanf("%d", &w);
			
			capacity[i][G + w] = INF;
		}
	}
}

int find_path(const int source, const int sink, const int nodes)
{
	for(int i = 0; i < nodes; i ++)
	{
		used[i] = false;
		flow[i] = 0;
		parent[i] = - 1;
	}
	
	q_top = 0;
	q[q_top ++] = source;
	used[source] = true;
	flow[source] = INF;
	
	for(int i = 0; i < q_top; i ++)
	{
		int now = q[i];
		
		for(int next = 0; next < nodes; next ++)
		{
			if(capacity[now][next] == 0) continue;
			if(used[next]) continue;
			
			q[q_top ++] = next;
			used[next] = true;
			flow[next] = min(flow[now], capacity[now][next]);
			parent[next] = now;
			
			if(next == sink)
			{
				goto augment;
			}
		}
	}
	
	augment:
	
	for(int now = sink; 0 <= parent[now]; now = parent[now])
	{
		capacity[parent[now]][now] -= flow[sink];
		capacity[now][parent[now]] += flow[sink];
	}
	
	return flow[sink];
}

int max_flow(const int source, const int sink, const int nodes)
{
int path_capacity, ret = 0;
	
	while(path_capacity = find_path(source, sink, nodes))
	{
		ret += path_capacity;
	}
	
	return ret;
}

void Solve()
{
	if(All_g < All_w) return;
	
	if(max_flow(0, W + G + 1, W + G + 2) == All_w) ans = true;
}

void Write()
{
	if(ans) printf("Yes\n");
	else printf("No\n");
}

int main()
{
	Read();
	
	Solve();
	
	Write();
	
	return 0;
}
