#include <stdio.h>
#include <string>
#include <algorithm>
using namespace std;

struct Vertex
{
	int u, dist, next;
	Vertex(int _u, int _dist, int _next):u(_u), dist(_dist), next(_next){}
	Vertex(){}
} nodes[500000];
int table[500000], cnt;
struct A
{
	int u, level;
	A(int _u, int _level):u(_u), level(_level){}
	A(){}
} Mar[1000000], RMQ[5000000];
int cntM = 0;

int N, M, K;
int dist[500000];
int lvl[500000];
int leftmost[500000];
void add(int a, int b, int dist)
{
	nodes[cnt] = Vertex(b, dist, table[a]);
	table[a] = cnt++;
}

void March(int k, int sofar, int lev)
{
	dist[k] = sofar;
	lvl[k] = lev;
	
	leftmost[k] = cntM+1;
	Mar[++cntM] = A(k, lev);
	for (int v = table[k]; v != -1; v = nodes[v].next)
	{
		March(nodes[v].u, sofar + nodes[v].dist, lev + 1);
		Mar[++cntM] = A(k, lev);
	}
}

void calcRMQ(int l, int r, int ind)
{
	if (l == r) { RMQ[ind] = Mar[l]; return; }
	
	int lind = 2*ind, rind = 2*ind + 1;
	calcRMQ(l, (l + r)/2, lind);
	calcRMQ((l + r)/2 + 1, r, rind);
	
	if (RMQ[lind].level < RMQ[rind].level) RMQ[ind] = RMQ[lind]; 
	else RMQ[ind] = RMQ[rind];
}

int query(int l, int r, int a, int b, int ind)
{
	if (a <= l && b >= r) return ind;
	//printf("%d %d\n", a, b);
	int minlev = 500001, ret;
	if (a <= (l + r)/2)
	{
		//system("pause");
		int rind = query(l, (l+r)/2, a, b, 2*ind);
		if (RMQ[rind].level < minlev) ret = rind, minlev = RMQ[rind].level;
	} 
	if (b >= (l + r)/2 + 1)
	{
		int lind = query((l + r)/2 + 1, r, a, b, 2*ind + 1);
		if (RMQ[lind].level < minlev) ret = lind, minlev = RMQ[lind].level;
	}
	return ret;
}

int main()
{
	memset(table, -1, sizeof(table));
    scanf("%d%d%d", &N, &M, &K);
	for (int i = 0; i < M; i++)
	{
		int a, b, dist;
		scanf("%d%d%d", &a, &b, &dist);
		add(a-1, b-1, dist);
    }
    March(0, 0, 0);
    calcRMQ(1, cntM, 1);
    //for (int i = 1; i <= cntM; i++) printf("%d( %d ) ", Mar[i].u, Mar[i].level);
    //printf("%d", cntM);
    
    //for (int i = 0; i < 6; i++) printf("%d ", leftmost[i]);
    for (int q = 0; q < K; q++)
    {
		int ans = 0;
		int c, m[50];
		scanf("%d", &c);
		for (int i = 0; i < c; i++) scanf("%d", &m[i]), m[i]--;		
		
		//system("pause");
		if (c > 1)
		{
		for (int i = 0; i < c; i++)
		{
			int maxlev = -1, minind = 0; 
			for (int j = 0; j < c; j++) if (j != i)
		    {
			  	int a = m[i], b = m[j];
			  	//printf("%d %d\n", leftmost[a], leftmost[b]);
				int ind =  query(1, cntM, min(leftmost[a], leftmost[b]),
				                          max(leftmost[a], leftmost[b]), 1);
				//printf("%d\n", ind);                          
				if (RMQ[ind].level > maxlev) maxlev = RMQ[ind].level, minind = ind;
		    }
		    
		    //printf("%d\n", RMQ[minind].u);  
		    ans += dist[m[i]] - dist[ RMQ[minind].u ] + dist[ RMQ[minind].u ]/2; 
			
		}
		}
		else ans += dist[m[0]];
		printf("%d\n", ans);;
	}
	//printf("%d\n", ans);
	return 0;
}
