#include <cstdio>
#include <queue>
#include <ctime>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 19;
const int MAXGROUP = 1 << 6;
const int LOG = 1 << 5;

#define pii pair<int,int>
#define mp make_pair

int n , m , k;
vector < pii > a[MAXN];

queue < int > q;
int dist[MAXN];
int depth[MAXN];

int p[MAXN << 1];
int cnt;

int wh[MAXN];
int r[MAXN << 1][LOG];

int t[MAXGROUP];
int lvl[MAXGROUP];

void read() {
    int x , y , z;
    
    scanf ("%d%d%d",&n,&m,&k);
    while ( m -- ) {
        scanf ("%d%d%d",&x,&y,&z);
        
        a[x].push_back ( mp ( y , z ) );
    }
}

void dfs ( int node ) {
    int i;
    
    p[ ++ cnt ] = node;
    wh[node] = cnt;
    
    for (i=0;i<(int)a[node].size();i++) {
        dfs ( a[node][i].first );
        p [ ++ cnt ] = node;
    }
}

void init_rmq () {
    int i , j;
    
    for (i=1;i<=cnt;i++)
        r[i][0] = p[i];
        
    for (j=1;(1 << j)<cnt;j++)
        for (i=1;i + (1 << j) - 1<=cnt;i++) {
            if ( depth[ r[i][j - 1] ] < depth[ r[i + (1 << (j - 1))][j - 1] ] )
                r[i][j] = r[i][j - 1];
            else
                r[i][j] = r[i + (1 << (j - 1))][j - 1];
        }
}

int ask ( int l , int ri ) {
    if ( ri < l ) {
        l ^= ri;
        ri ^= l;
        l ^= ri;
    }
    if ( l == ri ) return r[l][0];
    int i;
    
    for (i=0;(1 << (i+1)) <= (ri - l + 1);i++) ;
    if ( r[l][i] < r[ri - (1 << i) + 1][i] )
        return r[l][i];
    return r[ri - (1 << i) + 1][i];
}

void init() {
    int i;
    int x;
    
    dist[1] = depth[1] = 1;
    q.push ( 1 );
    
    while ( !q.empty() ) {
        x = q.front(); q.pop();
        
        for (i=0;i<(int)a[x].size();i++) {
            depth[ a[x][i].first ] = depth[x] + 1;
            dist[ a[x][i].first ] = dist[x] + a[x][i].second;
            q.push ( a[x][i].first );
        }
    }
    
    dfs ( 1 );
    
    init_rmq ();
}

void solve() {
    int i , j;
    int f;
    int x , y;
    int ans;
    int mn , mx;
    
    while ( k -- ) {
        scanf ("%d",&f);
        for (i=1;i<=f;i++)
            scanf ("%d",&t[i]);
            
        for (i=1;i<=f;i++)
            lvl[i] = 1;
            
        for (i=1;i<=f;i++) {
            mn = mx = -1;
            
            for (j=1;j<=f;j++) {
                if ( i == j ) continue;
                if ( (mn == -1 || wh[ t[j] ] <= wh[ mn ]) && wh[ t[j] ] >= wh[ t[i] ] )
                    mn = t[j];
                    
                if ( (mx == -1 || wh[ t[j] ] >= wh[ mx ]) && wh[ t[j] ] <= wh[ t[i] ] )
                    mx = t[j];
            }
            
            if ( mn == -1 ) 
                x = 1;
            else    
                x = ask ( wh[ mn ] , wh[ t[i] ] );
                
            if ( mx == -1 ) 
                y = 1;
            else    
                y = ask ( wh[ t[i] ] , wh[ mx ] );
                
            if ( depth[x] > depth[y] )
                lvl[i] = x;
            else
                lvl[i] = y;
        }
            
        ans = 0;
        for (i=1;i<=f;i++) {
            ans += dist[ lvl[i] ] / 2;
            ans += dist[ t[i] ] - dist[ lvl[i] ];
        }
            
        printf ("%d\n",ans);
    }
}

int main() {
    read();
    init();
    solve();
    
    return 0;
}
