#include <cstdio>
#include <cmath>

const int MAXN = 1 << 18;

int n , m;
int a[MAXN];

void read() {
    scanf ("%d%d",&n,&m);
}

void change ( int x , int y ) {
    int i;
    int lo , hi;
    
    lo = 0;
    hi = 2 * y;
    for (i = x - y;i <= x;i ++) {        
        if ( a[i] < lo ) a[i] = lo;
        if ( a[i] > hi ) a[i] = hi;
        lo ++;
        hi --;
    }
    for (i=x - y - 1;i >= 0;i --)
        if ( a[i] - 1 != a[i + 1] && a[i] + 1 != a[i + 1] ) {
            if ( a[i] > a[i + 1] ) a[i] = a[i + 1] + 1;
            if ( a[i] < a[i + 1] ) a[i] = a[i + 1] - 1;
        }
    
    lo = 0;
    hi = 2 * y;
    for (i=x + y;i >= x;i --) {
        if ( a[i] < lo ) a[i] = lo;
        if ( a[i] > hi ) a[i] = hi;
        lo ++;
        hi --;
    }
    for (i=x + y + 1;i <= n;i ++)
        if ( a[i] - 1 != a[i - 1] && a[i] + 1 != a[i - 1] ) {
            if ( a[i] > a[i - 1] ) a[i] = a[i - 1] + 1;
            if ( a[i] < a[i - 1] ) a[i] = a[i - 1] - 1;
        }
}

int calc ( int x , int y ) {
    int ans = 0;
    
    for (;x<y;x++)
        if ( a[x + 1] > a[x] )
            ans += a[x];
        else
            ans += a[x + 1];
            
    return ans;
}

void solve() {
    int i;
    int type;
    int x , y;
    double t;
    
    for (i=0;i<=n;i++)
        a[i] = i & 1;
    
    while ( m -- ) {
        scanf ("%d%d%d",&type,&x,&y);
        
        if ( type == 1 )
            change ( x , y );
            
        if ( type == 2 ) {
            t = (double)calc ( x , y ) + (double)(y - x) * (double)0.5;
            
            if ( fabs ( ceil ( t ) - t ) < 1e-7 )
                printf ("%.0lf\n",t);
            else
                printf ("%.1lf\n",t);
        }
    }
}

int main() {
    read();
    solve();
    
    return 0;
}
