#include <cstdio>
#include <cmath>

#define f(i, n) 					for(int i = 0 ; i < (n); i ++)
#define ff(i, st, end)				for(int i = (st); i < (end); i ++)
#define fv(i, v)					for(int i = 0 ; i < (int)(v).size(); i ++)
#define fx(i, v)					for( typeof( (v).begin() it = (v).begin(); it != (v).end(); it ++ )
#define all(v)						(v).begin(), (v).end()

int N, M;
int h[100005];
int tree[131075], size = 1;
int q[100005][3];
int count[3];

void update_tree(int pos, int value)
{
	pos ++;
	for(; pos <= size; pos += pos & (-pos))
		tree[pos] += value;
}

int query(int pos)
{
	pos ++;
	int res = 0;
	for(; pos; pos ^= pos & (-pos))
		res += tree[pos];
	return res;
}

void update(int x, int y)
{
	if( h[x] < y )							// increase
	{
		for(register int i = x, cur = y; (i >=0) && (h[i] < cur); i --, cur --)
			h[i] = cur;
		for(register int i = x + 1, cur = y - 1; (i >=0) && (h[i] < cur); i ++, cur --)
			h[i] = cur;
	}
	else
	{										// decrease
		for(register int i = x, cur = y; (i >=0) && (h[i] > cur); i --, cur ++)
			h[i] = cur;
		for(register int i = x + 1, cur = y + 1; (i >=0) && (h[i] > cur); i ++, cur ++)
			h[i] = cur;
	}
}

void update_Nlog(int x, int y)
{
	if( h[x] < y )							// increase
	{
		for(register int i = x, cur = y; (i >=0) && (h[i] < cur); i --, cur --)
		{
			update_tree( i, cur - h[i] );
			h[i] = cur;
		}
		for(register int i = x + 1, cur = y - 1; (i >=0) && (h[i] < cur); i ++, cur --)
		{
			update_tree( i, cur - h[i] );
			h[i] = cur;
		}
	}
	else
	{										// decrease
		for(register int i = x, cur = y; (i >=0) && (h[i] > cur); i --, cur ++)
		{
			update_tree( i, cur - h[i] );
			h[i] = cur;
		}
		for(register int i = x + 1, cur = y + 1; (i >=0) && (h[i] > cur); i ++, cur ++)
		{
			update_tree( i, cur - h[i] );
			h[i] = cur;
		}
	}
}

int area(int x1, int y1)
{
	int res = 0;
	ff(i, x1, y1 )	res += h[i] + h[i + 1];
	return res;
}

int area_log(int x1, int y1)
{
	int res = 0;
	res += query( y1 - 1 );
	res -= query( x1 );
	res <<= 1;
	res += h[x1];
	res += h[y1];
	return res;
}


int main()
{
	scanf("%d %d", &N, &M);
	while( size < N + 1 )	size <<= 1;
	f(i, N + 1)
	{
		update_tree(i, i & 1);
		h[i] = i & 1;
	}
/*	f(i, M)
	{
		f(i, N + 1) printf("%3d", h[i]);	printf("\n");
		f(i, N + 1) printf("%3d", query(i)); printf("\n");
		int type;
		scanf("%d", &type);
		if( type == 1 )
		{
			int x, y;
			scanf("%d %d", &x, &y);
			update(x, y);
		}
		else
		{
			int x1, x2;
			scanf("%d %d", &x1, &x2);
			printf("%d %d\n", area(x1, x2), area_log(x1, x2));
		}
	} */
	f(i, M)
	{
		scanf("%d %d %d", &q[i][0], &q[i][1], &q[i][2]);
		count[ q[i][0] ] ++;
	}
	double logn = log2( size );
	int cnt = count[1] + count[2];
	cnt *= N;
	int cnt_log = count[1] * N + count[2];
//	printf("%d %d\n", count[1] * N, count[2]);
	cnt_log = int(double(cnt_log * logn));
//	printf("%d %d\n", cnt, cnt_log);
	
//	cnt = int(1e7);
	if( cnt < cnt_log )
	{
		f(i, M)
			if( q[i][0] == 1 )
				update(q[i][1], q[i][2]);
			else
			{
				int res = area( q[i][1], q[i][2] );
				printf("%d", res >> 1);
				if( res & 1 )	printf(".5");
				printf("\n");
			}
	}
	else
	{
		f(i, M)
			if( q[i][0] == 1 )
				update_Nlog(q[i][1], q[i][2]);
			else
			{
				int res = area_log( q[i][1], q[i][2] );
				printf("%d", res >> 1);
				if( res & 1 )	printf(".5");
				printf("\n");
			}
	}
	
    return 0;
}
