#include <algorithm>
#include <cstdio>
#include <vector>
#include <queue>
using namespace std;

class udalost {
  public: 
    int pozicia, prikaz; bool zacina;
    udalost(int po=0, int pr=0, bool z=true) : pozicia(po), prikaz(pr), zacina(z) {}
};
bool skor(const udalost &a, const udalost &b) { return a.pozicia < b.pozicia; }

int N, F, K;
priority_queue<int> aktivne;
vector<bool> skoncil;
vector<udalost> udalosti;   // zaciatky a konce prikazov
vector<int> farby;          // ku kazdej farbe pocet litrov ktore treba
vector<int> farby_prikazov; // ku kazdemu prikazu jeho farba

int main() {
  // nacitame vstup
  scanf("%d%d%d",&N,&F,&K);
  for (int i=0; i<N; i++) {
    int z,k,f;
    scanf("%d%d%d",&z,&k,&f);
    farby_prikazov.push_back(f);
    udalosti.push_back(udalost(z,i,true)); 
    udalosti.push_back(udalost(k,i,false));
  }

  // utriedime udalosti
  sort( udalosti.begin(), udalosti.end(), skor );

  // spracujeme udalosti
  farby.resize(F+1,0);
  skoncil.resize(N,false);
  aktivne.push( udalosti[0].prikaz );
  for (int i=1; i<2*N; i++) {
    int farba = 0, dlzka = udalosti[i].pozicia - udalosti[i-1].pozicia;
    while (!aktivne.empty() && skoncil[aktivne.top()]) aktivne.pop();
    if (!aktivne.empty()) farba = farby_prikazov[ aktivne.top() ];
    farby[farba] += dlzka;
    if (udalosti[i].zacina) aktivne.push( udalosti[i].prikaz );
    else skoncil[ udalosti[i].prikaz ] = true;
  }

  // vypiseme vysledok
  for (int f=1; f<=F; f++) printf("%d\n",farby[f]);
}

