#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int N, F, K, D, L;
struct poziadavka { int zac, kon, farba; };
struct vrchol { int farba, dlzka; };
vector<poziadavka> P; // pole s poziadavkami
vector<vrchol> T; // intervalovy strom
vector<int> farby;

// nacitanie vstupu
void load() {
  cin >> N >> F >> K;
  poziadavka tmp;
  for (int i=0; i<N; i++) { 
    cin >> tmp.zac >> tmp.kon >> tmp.farba;
    P.push_back(tmp);
  }
}

// najdenie indexu prvku x v utriedenom poli
int najdi(int x, const vector<int> &pole) {
  int lo=0, hi=pole.size();
  while (hi-lo > 1) { int med=(hi+lo)/2; if (pole[med]<=x) lo=med; else hi=med; }
  return lo;
}

void build_tree() {
  // utriedime vsetky hranice poziadaviek
  vector<int> hranice;
  hranice.push_back(0); hranice.push_back(K);
  for (int i=0; i<N; i++) { hranice.push_back( P[i].zac ); hranice.push_back( P[i].kon ); }
  sort( hranice.begin(), hranice.end() );
  // vyhadzeme duplikaty
  D=1;
  for (int i=1; i<2*N+2; i++) if (hranice[i]!=hranice[i-1]) swap(hranice[i],hranice[D++]);
  hranice.resize(D);
  D--;
  // vyrobime strom
  for (int i=1; ; i*=2) if (i>D+7) { L=i; break; }
  T.resize(2*L);
  for (int i=0; i<D; i++) T[L+i].dlzka = hranice[i+1]-hranice[i];
  for (int i=L-1; i>=1; i--) T[i].dlzka = T[2*i].dlzka + T[2*i+1].dlzka;
  // prepiseme zaciatky a konce poziadaviek do noveho cislovania
  for (int i=0; i<N; i++) { 
    P[i].zac = najdi( P[i].zac, hranice );
    P[i].kon = najdi( P[i].kon, hranice );
  }
}

void color(int x, int kde=1, int left=0, int length=L) {
  if (P[x].kon <= left || P[x].zac>=left+length) return; // mimo
  if (P[x].zac <= left && left+length <= P[x].kon) { T[kde].farba=P[x].farba; return; } // dnu
  if (kde<L && T[kde].farba!=0) { 
    T[2*kde].farba=T[2*kde+1].farba=T[kde].farba;
    T[kde].farba=0;
  }
  color(x,2*kde,left,length/2);
  color(x,2*kde+1,left+length/2,length/2);
}

void evaluate(int kde) {
  if (kde>=L || T[kde].farba>0) farby[ T[kde].farba ] += T[kde].dlzka; 
  else { evaluate(2*kde); evaluate(2*kde+1); }
}

int main() {
  load();
  build_tree();
  for (int i=0; i<N; i++) color(i);
  farby.resize(F+1,0);
  evaluate(1);
  for (int f=1; f<=F; f++) cout << farby[f] << endl;
}
