{$MODE OBJFPC}  

type 
   udalost = record pozicia, prikaz : longint; zacina : boolean; end;
   generic Heap<T> = class
      type public
         TCompareFunc = function(const Item1, Item2: T) : boolean;  
      var public
         data : array[1..250000] of T;
         N : longint;
         less : TCompareFunc;
         constructor create;
         procedure push(co : T);
         function top : T;
         procedure pop;
   end;
   UHeap = specialize heap<udalost>;
   LHeap = specialize heap<longint>;

constructor Heap.create;
begin N := 0; end;

procedure Heap.push(co : T);
var i : integer;
    tmp : T;
begin
   inc(N);
   data[N] := co;
   i := N;
   while (i>1) and (less(data[i],data[i div 2])) do begin
      tmp           := data[i div 2];
      data[i div 2] := data[i];
      data[i]       := tmp;
      i := i div 2;
   end;
end;

function Heap.top : T; 
begin 
   result := data[1];
end;

procedure Heap.pop;
var i, j : longint;
    tmp : T;
begin
   if N>1 then data[1] := data[N];
   dec(N);
   i := 1;
   while true do begin
      j := i;
      if (2*i <= N) and (less(data[2*i],data[j])) then j:=2*i;
      if (2*i+1 <= N) and (less(data[2*i+1],data[j])) then j:=2*i+1;
      if j=i then break;
      tmp     := data[j];
      data[j] := data[i];
      data[i] := tmp;
      i := j;
   end;
end;

var udalosti : UHeap;
    aktivne : LHeap;
    N, F, K, i, zac, kon, last : longint;
    farby, farby_prikazov : array[1..100047] of longint;
    skoncil : array[1..100047] of boolean;
    ud : udalost;

function uless(const a, b : udalost) : boolean; begin result := a.pozicia < b.pozicia; end;
function lless(const a, b : longint) : boolean; begin result := a>b; end;

begin
   readln(N,F,K);
   aktivne := LHeap.create;   aktivne.less:=@lless;
   udalosti := UHeap.create;  udalosti.less:=@uless; 

   for i:=1 to N do begin
      readln(zac,kon,farby_prikazov[i]);
      ud.pozicia:=zac; ud.prikaz:=i; ud.zacina:=true;
      udalosti.push(ud);
      ud.pozicia:=kon; ud.prikaz:=i; ud.zacina:=false;
      udalosti.push(ud);
   end;

   for i:=1 to F do farby[i]:=0;
   for i:=1 to N do skoncil[i]:=false;

   aktivne.push( udalosti.top().prikaz );
   last := udalosti.top().pozicia;
   udalosti.pop();
   while udalosti.N > 0 do begin
      while (aktivne.N > 0) and (skoncil[ aktivne.top() ]) do aktivne.pop();
      if aktivne.N > 0 then
         inc( farby[ farby_prikazov[ aktivne.top() ] ], udalosti.top().pozicia - last );
      if udalosti.top().zacina then aktivne.push( udalosti.top().prikaz )
      else skoncil[ udalosti.top().prikaz ] := true;
      last := udalosti.top().pozicia;
      udalosti.pop();
   end;
   
   for i:=1 to F do writeln(farby[i]);
end.
