#include <iostream>
#include <vector>
#include <set>
using namespace std;

class zaznam {
  public: 
    int zac, kon, farba; 
    zaznam(int zac=0, int kon=0, int farba=0) : zac(zac), kon(kon), farba(farba) {}
};
bool operator< (const zaznam &a, const zaznam &b) { return a.zac < b.zac; }

int N, F, K;
set<zaznam> S;

int main() {
  cin >> N >> F >> K;
  S.insert(zaznam(-1,K+1,0));
  while (N--) {
    zaznam cur, next; 
    cin >> cur.zac >> cur.kon >> cur.farba;

    // spracuje interval obsahujuci lavy koniec poziadavky
    set<zaznam>::iterator left = S.lower_bound(cur);
    left--;
    if (left->kon > cur.kon) S.insert(zaznam(cur.kon,left->kon,left->farba));
    if (left->kon > cur.zac) {
      next = zaznam(left->zac,cur.zac,left->farba);
      S.erase(left);
      S.insert(next);
    }

    // pravy koniec poziadavky
    next = zaznam(cur.kon,K+1,0);
    set<zaznam>::iterator right = S.upper_bound(next);
    right--;
    if (right->zac < cur.kon) { S.insert(zaznam(cur.kon,right->kon,right->farba)); S.erase(*right);}

    // vymaze vsetky intervaly medzi nimi
    left = S.lower_bound(cur);
    right = S.upper_bound(next); right--;
    S.erase(left,right);

    // a vlozi novy
    S.insert(cur);
  }
  vector<int> farby(F+1,0);
  for (set<zaznam>::iterator it=S.begin(); it != S.end(); ++it) 
    farby[ it->farba ] += (it->kon)-(it->zac);
  for (int f=1; f<=F; f++) cout << farby[f] << endl;
}

