// riesenie pouzivajuce inverzne prvky a dynamicke programovanie
#include <algorithm>
#include <vector>
#include <cstdio>
using namespace std;

long long MODEXP(long long number, long long power, long long modulus) { 
  if (power==0) return 1LL % modulus; 
  if (power==1) return number % modulus; 
  long long tmp = MODEXP(number,power/2,modulus);
  tmp = (tmp*tmp) % modulus; 
  if (power&1) tmp = (tmp*number) % modulus; 
  return tmp; 
}

bool distless(const pair<int,int> &A, const pair<int,int> &B) {
  return A.first + A.second < B.first + B.second;
}

int main() {
  int R, S, N, K, P=1000000009;
  scanf("%d%d%d",&R,&S,&N);

  vector<int> fact(R+S+2);
  fact[0]=fact[1]=1;
  for (int i=2; i<R+S+2; ++i) fact[i] = (1LL * fact[i-1] * i) % P;
  vector<int> inverse(R+S+2);
  for (int i=0; i<R+S+2; ++i) inverse[i] = MODEXP(fact[i],P-2,P);

  while (N--) {
    scanf("%d",&K);
    vector< pair<int,int> > prekazky;
    for (int k=0; k<K; ++k) { 
      int x,y;
      scanf("%d%d",&x,&y);
      prekazky.push_back( make_pair(x,y) );
    }
    prekazky.push_back( make_pair(R,S) );
    sort( prekazky.begin(), prekazky.end(), distless );
    vector<long long> G(K+1);
    for (int k=0; k<=K; ++k) {
      int dx = prekazky[k].first, dy = prekazky[k].second;
      G[k] = (((1LL * fact[dx+dy] * inverse[dx]) % P) * inverse[dy]) % P;
    }
    for (int k=0; k<K; ++k)
      for (int l=k+1; l<=K; ++l) {
        int dx = prekazky[l].first - prekazky[k].first, 
            dy = prekazky[l].second - prekazky[k].second;
        if (dx<0 || dy<0) continue;
        long long C = (((1LL * fact[dx+dy] * inverse[dx]) % P) * inverse[dy]) % P;
        G[l] -= G[k] * C;
        G[l] %= P;
        if (G[l] < 0) G[l] += P;
      }
    printf("%Ld\n",G[K]);
  }
}
