#include <stdio.h>

#define NMAX 1001

#define max(a, b) ((a) > (b) ? (a) : (b))

int opt[NMAX], p[NMAX], lcs[NMAX];
int lmax[NMAX][NMAX];
int i, j, k, N, L, M;

int main()
{
	freopen("permlcs.in", "r", stdin);
	scanf("%d %d", &N, &M);

	// read the 1st permutation
	for (i = 1; i <= N; i++)
		scanf("%d", &opt[i]);

	L = N;

	for (k = 2; k <= M; k++)
	{
		for (i = 1; i <= N; i++)
			scanf("%d", &p[i]);

		// compute LCS between 'opt' and 'p'
		for (j = 0; j <= N; j++)
			lmax[0][j] = 0;

		for (i = 1; i <= L; i++)
		{
			lmax[i][0] = 0;
			for (j = 1; j <= N; j++)
			{
				if (opt[i] == p[j])
					lmax[i][j] = 1 + lmax[i - 1][j - 1];
				else
					lmax[i][j] = max(lmax[i - 1][j], lmax[i][j - 1]);
			}
		}

		// reconstruct the LCS between 'opt' and 'p'
		i = L; j = N;
		while (i > 0 && j > 0)
		{
			if (opt[i] == p[j])
			{
				lcs[lmax[i][j]] = opt[i];
				i--;
				j--;
			}
			else
			{
				if (lmax[i][j] == lmax[i][j - 1])
					j--;
				else
					i--;
			}
		}

		for (i = 1; i <= lmax[L][N]; i++)
			opt[i] = lcs[i];

		L = lmax[L][N];
	}

	freopen("permlcs.out", "w", stdout);
	printf("%d\n", L);
	fprintf(stderr, "%d\n", L);

	return 0;
}
