#include <stdio.h>
#include <string.h>

#define NMAX 1001

int A[NMAX][NMAX];
int p[NMAX], lmax[NMAX];
int i, j, k, q, N, M, ans;

void dfs(int x)
{
	int y;

	for (y = 1; y <= N; y++)
		if (A[x][y])
		{
			if (!lmax[y])
				dfs(y);

			if (lmax[y] > lmax[x])
				lmax[x] = lmax[y];
		}

	lmax[x]++;
}

int main()
{
	freopen("permlcs.in", "r", stdin);
	scanf("%d %d", &N, &M);

	// read the 1st permutation
	for (i = 1; i <= N; i++)
		scanf("%d", &p[i]);

	memset(A, 0, sizeof(A));
	for (i = 1; i < N; i++)
		for (j = i + 1; j <= N; j++)
			A[p[i]][p[j]] = 1;

	// read the other strings
	for (q = 2; q <= M; q++)
	{
		for (i = 1; i <= N; i++)
			scanf("%d", &p[i]);

		for (i = 1; i < N; i++)
			for (j = i + 1; j <= N; j++)
				if (A[p[j]][p[i]])
					A[p[j]][p[i]] = 0;
	}

	// find the longest path in the DAG
	memset(lmax, 0, sizeof(lmax));

	ans = 0;
	for (i = 1; i <= N; i++)
		if (!lmax[i])
		{
			dfs(i);

			if (lmax[i] > ans)
				ans = lmax[i];
		}

	freopen("permlcs.out", "w", stdout);
	printf("%d\n", ans);
	fprintf(stderr, "%d\n", ans);

	return 0;
}
