/*
 * Author: Andrei Homescu
 * Binary search solution, O(N*logS), 100 points
 */
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include <cstring>
#include <cctype>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <utility>
#include <string>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <stack>
#include <set>
#include <map>

using namespace std;

#define	REP( i, n )         for( (i) = 0 ; (i) < (n) ; (i)++ )
#define	IREP( i, n )	    for( (i) = (n) - 1 ; (i) >= 0 ; (i)-- )
#define REPV( i, a, b )     for( (i) = (a) ; (i) <= (b) ; (i)++ )
#define IREPV( i, a, b )    for( (i) = (b) ; (i) >= (a) ; (i)-- )
#define REPIT( it, x )      for( (it) = (x).begin( ) ; (it) != (x).end( ) ; (it)++ )
#define ALL( x )            (x).begin( ), (x).end( )
#define MP                  make_pair
#define PB                  push_back
#define CLR( x )            memset( (x), 0, sizeof( x ) )
#define CLRV( x, v )        memset( (x), (v), sizeof( x ) )
#define CPY( y, x )         memcpy( (y), (x), sizeof( x ) )
#define	X                   first
#define Y                   second

typedef long long Ll;
typedef pair< int, int > Pii;
typedef pair< Ll, Ll > Pll;
typedef vector< int > Vi;
typedef vector< Ll > Vl;
typedef vector< string > Vs;

const int MAXN = 131072, INF = 0x3f3f3f3f, ITER = 256;
const Ll INFL = 0x3f3f3f3f3f3f3f3fLL;
const double EPS = 1e-20;
int n, k;
float a[MAXN];
   
int okAvg( double avg, Pii *res )
{
    int i, first = 0;
    float sum = 0.0f, nval = 0.0f, sumk = 0.0f;
    for( i = 0 ; i < n ; i++ )
    {
        nval = logf( a[i] ) - avg;
        sum  += nval;
        sumk += nval;
        if( i >= k )
            sumk -= logf( a[i - k] ) - avg;

        if( sumk > sum )
        {
            sum = sumk;
            first = i - k + 1;
        }
        if( signbit( sum ) == 0 && i >= k - 1 )
        {
            res->X = first;
            res->Y = i;
            return 1;
        }
    }
    return 0;
}

int main( )
{
    freopen( "geom2.in", "r", stdin );
    freopen( "geom2.out", "w", stdout );

    int i;
    scanf( "%d%d", &n, &k );
    for( i = 0 ; i < n ; i++ )
        scanf( "%f", &a[i] );

    float vmax = a[0], vmin = a[0];
    for( i = 1 ; i < n ; i++ )
    {
        if( a[i] > vmax )
            vmax = a[i];
        if( a[i] < vmin )
            vmin = a[i];
    }

    Pii sol, cp;
    float x, y, m;
    for( x = -1.0f + log( vmin ), y = 1.0f + log( vmax ), 
            i = 0 ; (y - x) > EPS && i < ITER ; i++ )
    {
        m = 0.5f * (x + y);
        if( okAvg( m, &cp ) )
        {
            x = m;
            sol = cp;
        }
        else
            y = m;
    }
//    printf( "%.6lf\n", exp( x ) );
    printf( "%d %d\n", sol.X + 1, sol.Y + 1 );
    return 0;    
}
