/*
 * Author: Andrei Homescu
 * O(N*2^N) time, O(2^N) space, 100 points
 */
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include <cstring>
#include <cctype>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <utility>
#include <string>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <stack>
#include <set>
#include <map>

using namespace std;

#define	REP( i, n )         for( (i) = 0 ; (i) < (n) ; (i)++ )
#define	IREP( i, n )	    for( (i) = (n) - 1 ; (i) >= 0 ; (i)-- )
#define REPV( i, a, b )     for( (i) = (a) ; (i) <= (b) ; (i)++ )
#define IREPV( i, a, b )    for( (i) = (b) ; (i) >= (a) ; (i)-- )
#define REPIT( it, x )      for( (it) = (x).begin( ) ; (it) != (x).end( ) ; (it)++ )
#define ALL( x )            (x).begin( ), (x).end( )
#define MP                  make_pair
#define PB                  push_back
#define CLR( x )            memset( (x), 0, sizeof( x ) )
#define CLRV( x, v )        memset( (x), (v), sizeof( x ) )
#define CPY( y, x )         memcpy( (y), (x), sizeof( x ) )
#define	X                   first
#define Y                   second

typedef long long Ll;
typedef pair< int, int > Pii;
typedef pair< Ll, Ll > Pll;
typedef vector< int > Vi;
typedef vector< Ll > Vl;
typedef vector< string > Vs;

const int MAXN = 20, INF = 0x3f3f3f3f, MODULO = 9901;
const Ll INFL = 0x3f3f3f3f3f3f3f3fLL;
const double EPS = 1e-9;
int n;
int a[MAXN][MAXN], p[MAXN];
int vv[1 << MAXN];
    
int compute( int cols )
{
    if( vv[cols] != -1 )
        return vv[cols];

    int i, ln, res = 0;
    for( ln = 0, i = cols ; i > 0 ; i >>= 1 )
        ln += (i & 1);
    if( ln == n )
    {
        vv[cols] = 1;
        return 1;
    }

    for( i = 0 ; i < n ; i++ )
        if( (cols & (1 << i)) == 0 )
        {
            res += a[ln][i] * compute( cols | (1 << i) );
            res %= MODULO;
        }

    vv[cols] = res;
    return res;
}

int main( )
{
    freopen( "matperm.in", "r", stdin );
    freopen( "matperm.out", "w", stdout );

    int i, j;
    scanf( "%d", &n );
    for( i = 0 ; i < n ; i++ )
        for( j = 0 ; j < n ; j++ )
            scanf( "%d", &a[i][j] );

    memset( vv, -1, sizeof( vv ) );
    printf( "%d\n", compute( 0 ) );
    return 0;    
}
