#include <stdio.h>
#include <stdlib.h>
#include <map>

using namespace std;

#define NMAX 1001
#define NORMAL 0
#define NORMAL_OR_HEAVIER 1
#define NORMAL_OR_LIGHTER 2
#define NORMAL_OR_LIGHTER_OR_HEAVIER 3

#define min(u, v) ((u) < (v) ? (u) : (v))
#define max(u, v) ((u) > (v) ? (u) : (v))

int nmin[NMAX + 1][NMAX + 1], mon[NMAX], left[NMAX], right[NMAX], used[NMAX], cnt[4], c1[3], c2[3];
int i, j, k, N, M, T, Q, res, posib, not_normal, a, b, c, d, anext, bnext;

void DP(void)
{
	for (i = 0; i <= N; i++)
		for (j = 0; j <= N; j++)
			nmin[i][j] = NMAX;

	for (j = 0; j <= N; j++)
		nmin[0][j] = 0;
	
	nmin[1][0] = nmin[1][1] = 0;
	for (not_normal = 1; not_normal <= N; not_normal++)
	{
		// case 1: not_normal coins of types NORMAL_OR_LIGHTER and NORMAL_OR_HEAVIER
		if (not_normal == 1)
			nmin[2][1] = nmin[1][2] = 0;
		else
		for (i = 0; i <= not_normal; i++)
		{
			j = not_normal - i;
			nmin[i + 1][j + 1] = NMAX;
			for (a = 0; a <= i && a <= N / 2; a++)
				for (b = 0; b <= j && a + b <= N / 2; b++)
					if (a + b > 0)
					{
						for (c = 0; a + c <= i && c <= a + b; c++)
							for (d = 0; b + d <= j && c + d <= a + b; d++)
								if ((a + b) - (c + d) <= N - not_normal)
								{
									// potential weighting: a+b coins on each pan -- left pan = (a coins NORMAL_OR_HEAVIER, b coins NORMAL_OR_LIGHTER) ; right pan = (c coins NORMAL_OR_HEAVIER, d coins NORMAL_OR_LIGHTER, a+b-(c+d) coins NORMAL)
								// possible result 1: 0
									c1[0] = i - a - c;
									c2[0] = j - b - d;

									// possible result 2: -1
									c1[1] = a;
									c2[1] = d;

									// possible result 3: +1
									c1[2] = c;
									c2[2] = b;

									nmin[i + 1][j + 1] = min(nmin[i + 1][j + 1], 1 + max(nmin[c1[0] + 1][c2[0] + 1], max(nmin[c1[1] + 1][c2[1] + 1], nmin[c1[2] + 1][c2[2] + 1])));
								}
					}
		}

		// case 2: not_normal coins of type NORMAL_OR_LIGHTER_OR_HEAVIER
		nmin[not_normal + 1][0] = NMAX;
		for (a = 1; a <= not_normal && a <= N / 2; a++)
			for (b = 0; b <= not_normal - a && b <= a; b++)
				if (a - b <= N - not_normal)
				{
					// potential weighting: a coins on each pan -- left pan = (a not_normal) ; right pan = (b not_normal, a-b normal)
					// possible result 1: 0
					c1[0] = not_normal - a - b;
					c2[0] = -1;

					// possible result 2: -1
					c1[1] = a;
					c2[1] = b;

					// possible result 3: +1
					c1[2] = b;
					c2[2] = a;

					nmin[not_normal + 1][0] = min(nmin[not_normal + 1][0], 1 + max(nmin[c1[0] + 1][c2[0] + 1], max(nmin[c1[1] + 1][c2[1] + 1], nmin[c1[2] + 1][c2[2] + 1])));
					}
	}
}

void nosol(void)
{
	printf("-1\n");
	exit(0);
}

int main()
{
	freopen("moneda.in", "r", stdin);
	freopen("moneda.out", "w", stdout);

	scanf("%d %d", &N, &T);

	DP();

	while (T--)
	{
		for (i = 1; i <= N; i++)
			mon[i] = NORMAL_OR_LIGHTER_OR_HEAVIER;

		scanf("%d", &M);
		// read the weightings
		while (M--)
		{
			scanf("%d", &k);

			memset(used, 0, sizeof(used));

			for (i = 1; i <= k; i++)
			{
				scanf("%d", &left[i]);
				used[left[i]] = 1;
			}
		
			for (i = 1; i <= k; i++)
			{
				scanf("%d", &right[i]);
				used[right[i]] = 1;
			}
		
			scanf("%d", &res);

			if (res == 0)
			{
				for (i = 1; i <= k; i++)
					mon[left[i]] = mon[right[i]] = NORMAL;
			}
			else
			{
				for (i = 1; i <= N; i++)
					if (!used[i])
						mon[i] = NORMAL;

				posib = 0;
				for (i = 1; i <= k; i++)
				{
					if (res == -1)
					{
						if (mon[left[i]] == NORMAL_OR_LIGHTER_OR_HEAVIER)
							mon[left[i]] = NORMAL_OR_HEAVIER,
							posib = 1;
						else
						if (mon[left[i]] == NORMAL_OR_LIGHTER)
							mon[left[i]] = NORMAL;
						else
						if (mon[left[i]] == NORMAL_OR_HEAVIER)
							posib = 1;
					}
					else
					{
						if (mon[left[i]] == NORMAL_OR_LIGHTER_OR_HEAVIER)
							mon[left[i]] = NORMAL_OR_LIGHTER,
							posib = 1;
						else
						if (mon[left[i]] == NORMAL_OR_LIGHTER)
							posib = 1;
						else
						if (mon[left[i]] == NORMAL_OR_HEAVIER)
							mon[left[i]] = NORMAL;
					}
				}

				for (i = 1; i <= k; i++)
				{
					if (res == 1)
					{
						if (mon[right[i]] == NORMAL_OR_LIGHTER_OR_HEAVIER)
							mon[right[i]] = NORMAL_OR_HEAVIER,
							posib = 1;
						else
						if (mon[right[i]] == NORMAL_OR_LIGHTER)
							mon[right[i]] = NORMAL;
						else
						if (mon[right[i]] == NORMAL_OR_HEAVIER)
							posib = 1;
					}
					else
					{
						if (mon[right[i]] == NORMAL_OR_LIGHTER_OR_HEAVIER)
							mon[right[i]] = NORMAL_OR_LIGHTER,
							posib = 1;
						else
						if (mon[right[i]] == NORMAL_OR_LIGHTER)
							posib = 1;
						else
						if (mon[right[i]] == NORMAL_OR_HEAVIER)
							mon[right[i]] = NORMAL;
					}
				}

				if (!posib)
					nosol();
			}
		}

		memset(cnt, 0, sizeof(cnt));
		for (i = 1; i <= N; i++)
			cnt[mon[i]]++;

		if (cnt[NORMAL_OR_LIGHTER_OR_HEAVIER] > 0)
			printf("%d\n", nmin[cnt[NORMAL_OR_LIGHTER_OR_HEAVIER] + 1][0]);
		else
			printf("%d\n", nmin[cnt[NORMAL_OR_HEAVIER] + 1][cnt[NORMAL_OR_LIGHTER] + 1]);
	}

	return 0;
}
